fstests: remove old electric fence support
[xfstests-dev.git] / common / rc
index 2639fbdab535c5ac71b5bb715ef8b50759265438..ee677e7dc6b2b5cab801846485d15bb3e329b375 100644 (file)
--- a/common/rc
+++ b/common/rc
@@ -33,6 +33,16 @@ BC=$(which bc 2> /dev/null) || BC=
 VALID_TEST_ID="[0-9]\{3\}"
 VALID_TEST_NAME="$VALID_TEST_ID-\?[[:alnum:]-]*"
 
+# Some tests are not relevant or functional when testing XFS realtime
+# subvolumes along with the rtinherit=1 mkfs option.  In these cases,
+# this test will opt-out of the test.
+_require_no_rtinherit()
+{
+       [ "$FSTYP" = "xfs" ] && echo "$MKFS_OPTIONS" |
+               egrep -q "rtinherit([^=]|=1|$)" && \
+               _notrun "rtinherit mkfs option is not supported by this test."
+}
+
 _require_math()
 {
        if [ -z "$BC" ]; then
@@ -43,12 +53,7 @@ _require_math()
 _math()
 {
        [ $# -le 0 ] && return
-       if [ "$BC" ]; then
-               result=$(LANG=C echo "scale=0; $@" | "$BC" -q 2> /dev/null)
-       else
-               _notrun "this test requires 'bc' tool for doing math operations"
-       fi
-       echo "$result"
+       LANG=C echo "scale=0; $@" | "$BC" -q 2> /dev/null
 }
 
 dd()
@@ -76,22 +81,22 @@ _md5_checksum()
 
 # Write a byte into a range of a file
 _pwrite_byte() {
-       pattern="$1"
-       offset="$2"
-       len="$3"
-       file="$4"
-       xfs_io_args="$5"
+       local pattern="$1"
+       local offset="$2"
+       local len="$3"
+       local file="$4"
+       local xfs_io_args="$5"
 
        $XFS_IO_PROG $xfs_io_args -f -c "pwrite -S $pattern $offset $len" "$file"
 }
 
 # mmap-write a byte into a range of a file
 _mwrite_byte() {
-       pattern="$1"
-       offset="$2"
-       len="$3"
-       mmap_len="$4"
-       file="$5"
+       local pattern="$1"
+       local offset="$2"
+       local len="$3"
+       local mmap_len="$4"
+       local file="$5"
 
        $XFS_IO_PROG -f -c "mmap -rw 0 $mmap_len" -c "mwrite -S $pattern $offset $len" "$file"
 }
@@ -115,6 +120,25 @@ then
     fi
 fi
 
+_dump_err()
+{
+    _err_msg="$*"
+    echo "$_err_msg"
+}
+
+_dump_err2()
+{
+    _err_msg="$*"
+    >2& echo "$_err_msg"
+}
+
+_log_err()
+{
+    _err_msg="$*"
+    echo "$_err_msg" | tee -a $seqres.full
+    echo "(see $seqres.full for details)"
+}
+
 # make sure we have a standard umask
 umask 022
 
@@ -143,26 +167,85 @@ case "$FSTYP" in
         [ "$MKFS_F2FS_PROG" = "" ] && _fatal "mkfs.f2fs not found"
         ;;
     nfs)
+        . ./common/nfs
         ;;
     cifs)
         ;;
+    9p)
+        ;;
     ceph)
         ;;
+    glusterfs)
+        ;;
     overlay)
+        . ./common/overlay
         ;;
     reiser4)
         [ "$MKFS_REISER4_PROG" = "" ] && _fatal "mkfs.reiser4 not found"
         ;;
+    pvfs2)
+       ;;
+    ubifs)
+       [ "$UBIUPDATEVOL_PROG" = "" ] && _fatal "ubiupdatevol not found"
+       ;;
 esac
 
+if [ ! -z "$REPORT_LIST" ]; then
+       . ./common/report
+       _assert_report_list
+fi
+
 _mount()
 {
     $MOUNT_PROG `_mount_ops_filter $*`
 }
 
+# Call _mount to do mount operation but also save mountpoint to
+# MOUNTED_POINT_STACK. Note that the mount point must be the last parameter
+_get_mount()
+{
+       local mnt_point=${!#}
+       local mnt_dev=${@:(-2):1}
+       local scratch_opts=""
+       if [ "$mnt_dev" = "$SCRATCH_DEV" ]; then
+               _scratch_options mount
+               scratch_opts="$SCRATCH_OPTIONS"
+       fi
+
+       _mount $scratch_opts $*
+       if [ $? -eq 0 ]; then
+               MOUNTED_POINT_STACK="$mnt_point $MOUNTED_POINT_STACK"
+       else
+               return 1
+       fi
+}
+
+# Unmount the last mounted mountpoint in MOUNTED_POINT_STACK
+# and return it to caller
+_put_mount()
+{
+       local last_mnt=`echo $MOUNTED_POINT_STACK | awk '{print $1}'`
+
+       if [ -n "$last_mnt" ]; then
+               $UMOUNT_PROG $last_mnt
+       fi
+       MOUNTED_POINT_STACK=`echo $MOUNTED_POINT_STACK | cut -d\  -f2-`
+}
+
+# Unmount all mountpoints in MOUNTED_POINT_STACK and clear the stack
+_clear_mount_stack()
+{
+       if [ -n "$MOUNTED_POINT_STACK" ]; then
+               $UMOUNT_PROG $MOUNTED_POINT_STACK
+       fi
+       MOUNTED_POINT_STACK=""
+}
+
 _scratch_options()
 {
-    type=$1
+    local type=$1
+    local rt_opt=""
+    local log_opt=""
     SCRATCH_OPTIONS=""
 
     if [ "$FSTYP" != "xfs" ]; then
@@ -171,7 +254,7 @@ _scratch_options()
 
     case $type in
     mkfs)
-       [ "$HOSTOS" != "IRIX" ] && SCRATCH_OPTIONS="$SCRATCH_OPTIONS -f"
+       SCRATCH_OPTIONS="$SCRATCH_OPTIONS -f"
        rt_opt="-r"
         log_opt="-l"
        ;;
@@ -188,7 +271,9 @@ _scratch_options()
 
 _test_options()
 {
-    type=$1
+    local type=$1
+    local rt_opt=""
+    local log_opt=""
     TEST_OPTIONS=""
 
     if [ "$FSTYP" != "xfs" ]; then
@@ -213,22 +298,15 @@ _test_options()
 
 _mount_ops_filter()
 {
-    params="$*"
-    
+    local params="$*"
+    local last_index=$(( $# - 1 ))
+
     #get mount point to handle dmapi mtpt option correctly
-    let last_index=$#-1
     [ $last_index -gt 0 ] && shift $last_index
-    FS_ESCAPED=$1
-    
-    # irix is fussy about how it is fed its mount options
-    # - multiple -o's are not allowed
-    # - no spaces between comma delimitered options
-    # the sed script replaces all -o's (except the first) with a comma
-    # not required for linux, but won't hurt
-    
-    echo $params | sed -e 's/[[:space:]]\+-o[[:space:]]*/UnIqUe/1; s/[[:space:]]\+-o[[:space:]]*/,/g; s/UnIqUe/ -o /1' \
-        | sed -e 's/dmapi/dmi/' \
-        | $PERL_PROG -ne "s#mtpt=[^,|^\n|^\s]*#mtpt=$FS_ESCAPED\1\2#; print;"
+    local fs_escaped=$1
+
+    echo $params | sed -e 's/dmapi/dmi/' \
+        | $PERL_PROG -ne "s#mtpt=[^,|^\n|^\s]*#mtpt=$fs_escaped\1\2#; print;"
 
 }
 
@@ -240,101 +318,53 @@ _common_dev_mount_options()
        echo $MOUNT_OPTIONS $SELINUX_MOUNT_OPTIONS $*
 }
 
-_overlay_basic_mount_options()
-{
-       echo "-o lowerdir=$1/$OVERLAY_LOWER_DIR,upperdir=$1/$OVERLAY_UPPER_DIR,workdir=$1/$OVERLAY_WORK_DIR"
-}
-
-_overlay_mount_options()
-{
-       echo `_common_dev_mount_options` \
-            `_overlay_basic_mount_options $1` \
-            $OVERLAY_MOUNT_OPTIONS
-}
-
 _scratch_mount_options()
 {
        _scratch_options mount
 
-       if [ "$FSTYP" == "overlay" ]; then
-               echo `_overlay_mount_options $SCRATCH_DEV`
-               return 0
-       fi
        echo `_common_dev_mount_options $*` $SCRATCH_OPTIONS \
                                        $SCRATCH_DEV $SCRATCH_MNT
 }
 
-# helper function to do the actual overlayfs mount operation
-_overlay_mount_dirs()
-{
-       local lowerdir=$1
-       local upperdir=$2
-       local workdir=$3
-       shift 3
-
-       $MOUNT_PROG -t overlay -o lowerdir=$lowerdir -o upperdir=$upperdir \
-                   -o workdir=$workdir $*
-}
-
-# Given a dir, set up 3 subdirectories and mount on the given mnt.
-# The dir is used as the mount device so it can be seen from df or mount
-_overlay_mount()
+_supports_filetype()
 {
        local dir=$1
-       local mnt=$2
-       shift 2
 
-       local upper_fst=$(df --output=fstype $dir | tail -1)
-       case "$upper_fst" in
+       local fstyp=`$DF_PROG $dir | tail -1 | $AWK_PROG '{print $2}'`
+       case "$fstyp" in
        xfs)
-               if ! xfs_info $dir | grep -q "ftype=1" ; then
-                       _notrun "upper fs needs to support d_type"
-               fi
+               xfs_info $dir | grep -q "ftype=1"
                ;;
        ext2|ext3|ext4)
-               if ! tune2fs -l $(df --output=source $dir | tail -1) | \
-                  grep -q filetype ; then
-                       _notrun "upper fs needs to support d_type"
-               fi
+               local dev=`$DF_PROG $dir | tail -1 | $AWK_PROG '{print $1}'`
+               tune2fs -l $dev | grep -q filetype
+               ;;
+       *)
+               local testfile=$dir/$$.ftype
+               touch $testfile
+               # look for DT_UNKNOWN files
+               local unknowns=$(src/t_dir_type $dir u | wc -l)
+               rm $testfile
+               # 0 unknowns is success
+               return $unknowns
                ;;
        esac
-
-       mkdir -p $dir/$OVERLAY_UPPER_DIR
-       mkdir -p $dir/$OVERLAY_LOWER_DIR
-       mkdir -p $dir/$OVERLAY_WORK_DIR
-
-       _overlay_mount_dirs $dir/$OVERLAY_LOWER_DIR $dir/$OVERLAY_UPPER_DIR \
-                           $dir/$OVERLAY_WORK_DIR $OVERLAY_MOUNT_OPTIONS \
-                           $SELINUX_MOUNT_OPTIONS $* $dir $mnt
-}
-
-_overlay_test_mount()
-{
-       _overlay_mount $TEST_DEV $TEST_DIR $*
-}
-
-_overlay_scratch_mount()
-{
-       _overlay_mount $SCRATCH_DEV $SCRATCH_MNT $*
-}
-
-_overlay_test_unmount()
-{
-       $UMOUNT_PROG $TEST_DIR
 }
 
-_overlay_scratch_unmount()
+# mount scratch device with given options but don't check mount status
+_try_scratch_mount()
 {
-       $UMOUNT_PROG $SCRATCH_MNT
+       if [ "$FSTYP" == "overlay" ]; then
+               _overlay_scratch_mount $*
+               return $?
+       fi
+       _mount -t $FSTYP `_scratch_mount_options $*`
 }
 
+# mount scratch device with given options and _fail if mount fails
 _scratch_mount()
 {
-    if [ "$FSTYP" == "overlay" ]; then
-        _overlay_scratch_mount $*
-        return $?
-    fi
-    _mount -t $FSTYP `_scratch_mount_options $*`
+       _try_scratch_mount $* || _fail "mount failed"
 }
 
 _scratch_unmount()
@@ -373,7 +403,24 @@ _scratch_cycle_mount()
        opts="-o $opts"
     fi
     _scratch_unmount
-    _scratch_mount "$opts"
+    _try_scratch_mount "$opts" || _fail "cycle mount failed"
+}
+
+_scratch_shutdown()
+{
+       if [ $FSTYP = "overlay" ]; then
+               # In lagacy overlay usage, it may specify directory as
+               # SCRATCH_DEV, in this case OVL_BASE_SCRATCH_DEV
+               # will be null, so check OVL_BASE_SCRATCH_DEV before
+               # running shutdown to avoid shutting down base fs accidently.
+               if [ -z $OVL_BASE_SCRATCH_DEV ]; then
+                       _fail "_scratch_shutdown: call _require_scratch_shutdown first in test"
+               else
+                       src/godown $* $OVL_BASE_SCRATCH_MNT
+               fi
+       else
+               src/godown $* $SCRATCH_MNT
+       fi
 }
 
 _test_mount()
@@ -410,20 +457,67 @@ _scratch_mkfs_options()
     echo $SCRATCH_OPTIONS $MKFS_OPTIONS $* $SCRATCH_DEV
 }
 
+# Do the actual mkfs work on SCRATCH_DEV. Firstly mkfs with both MKFS_OPTIONS
+# and user specified mkfs options, if that fails (due to conflicts between mkfs
+# options), do a second mkfs with only user provided mkfs options.
+#
+# First param is the mkfs command without any mkfs options and device.
+# Second param is the filter to remove unnecessary messages from mkfs stderr.
+# Other extra mkfs options are followed.
+_scratch_do_mkfs()
+{
+       local mkfs_cmd=$1
+       local mkfs_filter=$2
+       shift 2
+       local extra_mkfs_options=$*
+       local mkfs_status
+       local tmp=`mktemp -u`
+
+       # save mkfs output in case conflict means we need to run again.
+       # only the output for the mkfs that applies should be shown
+       eval "$mkfs_cmd $MKFS_OPTIONS $extra_mkfs_options $SCRATCH_DEV" \
+               2>$tmp.mkfserr 1>$tmp.mkfsstd
+       mkfs_status=$?
+
+       # a mkfs failure may be caused by conflicts between $MKFS_OPTIONS and
+       # $extra_mkfs_options
+       if [ $mkfs_status -ne 0 -a -n "$extra_mkfs_options" ]; then
+               (
+               echo -n "** mkfs failed with extra mkfs options "
+               echo "added to \"$MKFS_OPTIONS\" by test $seq **"
+               echo -n "** attempting to mkfs using only test $seq "
+               echo "options: $extra_mkfs_options **"
+               ) >> $seqres.full
+
+               # running mkfs again. overwrite previous mkfs output files
+               eval "$mkfs_cmd $extra_mkfs_options $SCRATCH_DEV" \
+                       2>$tmp.mkfserr 1>$tmp.mkfsstd
+               mkfs_status=$?
+       fi
+
+       # output stored mkfs output, filtering unnecessary output from stderr
+       cat $tmp.mkfsstd
+       eval "cat $tmp.mkfserr | $mkfs_filter" >&2
+
+       rm -f $tmp.mkfserr $tmp.mkfsstd
+       return $mkfs_status
+}
+
 _scratch_metadump()
 {
-       dumpfile=$1
-       options=
+       local dumpfile=$1
+       shift
+       local options=
 
        [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
                options="-l $SCRATCH_LOGDEV"
 
-       xfs_metadump $options $SCRATCH_DEV $dumpfile
+       xfs_metadump $options "$@" $SCRATCH_DEV $dumpfile
 }
 
 _setup_large_ext4_fs()
 {
-       fs_size=$1
+       local fs_size=$1
        local tmp_dir=/tmp/
 
        [ "$LARGE_SCRATCH_DEV" != yes ] && return 0
@@ -432,11 +526,11 @@ _setup_large_ext4_fs()
 
        # Default free space in the FS is 50GB, but you can specify more via
        # SCRATCH_DEV_EMPTY_SPACE
-       space_to_consume=$(($fs_size - 50*1024*1024*1024 - $SCRATCH_DEV_EMPTY_SPACE))
+       local space_to_consume=$(($fs_size - 50*1024*1024*1024 - $SCRATCH_DEV_EMPTY_SPACE))
 
        # mount the filesystem and create 16TB - 4KB files until we consume
        # all the necessary space.
-       _scratch_mount 2>&1 >$tmp_dir/mnt.err
+       _try_scratch_mount 2>&1 >$tmp_dir/mnt.err
        local status=$?
        if [ $status -ne 0 ]; then
                echo "mount failed"
@@ -446,8 +540,8 @@ _setup_large_ext4_fs()
        fi
        rm -f $tmp_dir/mnt.err
 
-       file_size=$((16*1024*1024*1024*1024 - 4096))
-       nfiles=0
+       local file_size=$((16*1024*1024*1024*1024 - 4096))
+       local nfiles=0
        while [ $space_to_consume -gt $file_size ]; do
 
                xfs_io -F -f \
@@ -484,34 +578,21 @@ _setup_large_ext4_fs()
 
 _scratch_mkfs_ext4()
 {
-       # extra mkfs options can be added by tests
-       local extra_mkfs_options=$*
-
-       local tmp_dir=/tmp/
-
-       $MKFS_EXT4_PROG -F $MKFS_OPTIONS $extra_mkfs_options $SCRATCH_DEV \
-                       2>$tmp_dir.mkfserr 1>$tmp_dir.mkfsstd
-       local mkfs_status=$?
+       local mkfs_cmd="$MKFS_EXT4_PROG -F"
+       local mkfs_filter="grep -v -e ^Warning: -e \"^mke2fs \""
+       local tmp=`mktemp -u`
+       local mkfs_status
 
-       # a mkfs failure may be caused by conflicts between
-       # $MKFS_OPTIONS and $extra_mkfs_options
-       if [ $mkfs_status -ne 0 -a ! -z "$extra_mkfs_options" ]; then
-               (
-               echo -n "** mkfs failed with extra mkfs options "
-               echo "added to \"$MKFS_OPTIONS\" by test $seq **"
-               echo -n "** attempting to mkfs using only test $seq "
-               echo "options: $extra_mkfs_options **"
-               ) >> $seqres.full
+       [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
+           $mkfs_cmd -O journal_dev $MKFS_OPTIONS $SCRATCH_LOGDEV && \
+           mkfs_cmd="$mkfs_cmd -J device=$SCRATCH_LOGDEV"
 
-               # running mkfs again. overwrite previous mkfs output files
-               $MKFS_EXT4_PROG -F $extra_mkfs_options $SCRATCH_DEV \
-                               2>$tmp_dir.mkfserr 1>$tmp_dir.mkfsstd
-               local mkfs_status=$?
-       fi
+       _scratch_do_mkfs "$mkfs_cmd" "$mkfs_filter" $* 2>$tmp.mkfserr 1>$tmp.mkfsstd
+       mkfs_status=$?
 
        if [ $mkfs_status -eq 0 -a "$LARGE_SCRATCH_DEV" = yes ]; then
                # manually parse the mkfs output to get the fs size in bytes
-               fs_size=`cat $tmp_dir.mkfsstd | awk ' \
+               local fs_size=`cat $tmp.mkfsstd | awk ' \
                        /^Block size/ { split($2, a, "="); bs = a[2] ; } \
                        / inodes, / { blks = $3 } \
                        /reserved for the super user/ { resv = $1 } \
@@ -521,10 +602,10 @@ _scratch_mkfs_ext4()
                mkfs_status=$?
        fi
 
-       # output stored mkfs output
-       grep -v -e ^Warning: -e "^mke2fs " $tmp_dir.mkfserr >&2
-       cat $tmp_dir.mkfsstd
-       rm -f $tmp_dir.mkfserr $tmp_dir.mkfsstd
+       # output mkfs stdout and stderr
+       cat $tmp.mkfsstd
+       cat $tmp.mkfserr >&2
+       rm -f $tmp.mkfserr $tmp.mkfsstd
 
        return $mkfs_status
 }
@@ -538,12 +619,21 @@ _test_mkfs()
     cifs)
        # do nothing for cifs
        ;;
+    9p)
+       # do nothing for 9p
+       ;;
     ceph)
        # do nothing for ceph
        ;;
+    glusterfs)
+       # do nothing for glusterfs
+       ;;
     overlay)
        # do nothing for overlay
        ;;
+    pvfs2)
+       # do nothing for pvfs2
+       ;;
     udf)
         $MKFS_UDF_PROG $MKFS_OPTIONS $* $TEST_DEV > /dev/null
        ;;
@@ -561,38 +651,48 @@ _test_mkfs()
 
 _mkfs_dev()
 {
+    local tmp=`mktemp -u`
     case $FSTYP in
     nfs*)
        # do nothing for nfs
        ;;
+    9p)
+       # do nothing for 9p
+       ;;
     overlay)
        # do nothing for overlay
        ;;
+    pvfs2)
+       # do nothing for pvfs2
+       ;;
     udf)
-        $MKFS_UDF_PROG $MKFS_OPTIONS $* 2>$tmp_dir.mkfserr 1>$tmp_dir.mkfsstd
+        $MKFS_UDF_PROG $MKFS_OPTIONS $* 2>$tmp.mkfserr 1>$tmp.mkfsstd
        ;;
     btrfs)
-        $MKFS_BTRFS_PROG $MKFS_OPTIONS $* 2>$tmp_dir.mkfserr 1>$tmp_dir.mkfsstd
+        $MKFS_BTRFS_PROG $MKFS_OPTIONS $* 2>$tmp.mkfserr 1>$tmp.mkfsstd
        ;;
     ext2|ext3|ext4)
        $MKFS_PROG -t $FSTYP -- -F $MKFS_OPTIONS $* \
-               2>$tmp_dir.mkfserr 1>$tmp_dir.mkfsstd
+               2>$tmp.mkfserr 1>$tmp.mkfsstd
+       ;;
+    xfs)
+       $MKFS_PROG -t $FSTYP -- -f $MKFS_OPTIONS $* \
+               2>$tmp.mkfserr 1>$tmp.mkfsstd
        ;;
-
     *)
        yes | $MKFS_PROG -t $FSTYP -- $MKFS_OPTIONS $* \
-               2>$tmp_dir.mkfserr 1>$tmp_dir.mkfsstd
+               2>$tmp.mkfserr 1>$tmp.mkfsstd
        ;;
     esac
 
     if [ $? -ne 0 ]; then
        # output stored mkfs output
-       cat $tmp_dir.mkfserr >&2
-       cat $tmp_dir.mkfsstd
+       cat $tmp.mkfserr >&2
+       cat $tmp.mkfsstd
        status=1
        exit 1
     fi
-    rm -f $tmp_dir.mkfserr $tmp_dir.mkfsstd
+    rm -f $tmp.mkfserr $tmp.mkfsstd
 }
 
 # remove all files in $SCRATCH_MNT, useful when testing on NFS/CIFS
@@ -600,10 +700,15 @@ _scratch_cleanup_files()
 {
        case $FSTYP in
        overlay)
-               # $SCRATCH_DEV is a valid directory in overlay case
-               rm -rf $SCRATCH_DEV/*
+               # Avoid rm -rf /* if we messed up
+               [ -n "$OVL_BASE_SCRATCH_MNT" ] || return 1
+               _overlay_base_scratch_mount || return 1
+               rm -rf $OVL_BASE_SCRATCH_MNT/* || return 1
+               _overlay_mkdirs $OVL_BASE_SCRATCH_MNT
+               # leave base fs mouted so tests can setup lower/upper dir files
                ;;
        *)
+               [ -n "$SCRATCH_MNT" ] || return 1
                _scratch_mount
                rm -rf $SCRATCH_MNT/*
                _scratch_unmount
@@ -613,51 +718,72 @@ _scratch_cleanup_files()
 
 _scratch_mkfs()
 {
-    case $FSTYP in
-    xfs)
-        _scratch_mkfs_xfs $*
-       ;;
-    nfs*)
-       # unable to re-create NFS, just remove all files in $SCRATCH_MNT to
-       # avoid EEXIST caused by the leftover files created in previous runs
-        _scratch_cleanup_files
-       ;;
-    cifs)
-       # unable to re-create CIFS, just remove all files in $SCRATCH_MNT to
-       # avoid EEXIST caused by the leftover files created in previous runs
-        _scratch_cleanup_files
-       ;;
-    ceph)
-       # Don't re-create CephFS, just remove all files
-       _scratch_cleanup_files
-       ;;
-    overlay)
-       # unable to re-create overlay, remove all files in $SCRATCH_MNT to
-       # avoid EEXIST caused by the leftover files created in previous runs
-        _scratch_cleanup_files
-       ;;
-    udf)
-        $MKFS_UDF_PROG $MKFS_OPTIONS $* $SCRATCH_DEV > /dev/null
-       ;;
-    btrfs)
-        $MKFS_BTRFS_PROG $MKFS_OPTIONS $* $SCRATCH_DEV > /dev/null
-       ;;
-    ext2|ext3)
-       $MKFS_PROG -t $FSTYP -- -F $MKFS_OPTIONS $* $SCRATCH_DEV
-       ;;
-    ext4)
-       _scratch_mkfs_ext4 $*
-       ;;
-    tmpfs)
-       # do nothing for tmpfs
-       ;;
-    f2fs)
-        $MKFS_F2FS_PROG $MKFS_OPTIONS $* $SCRATCH_DEV > /dev/null
-       ;;
-    *)
-       yes | $MKFS_PROG -t $FSTYP -- $MKFS_OPTIONS $* $SCRATCH_DEV
-       ;;
-    esac
+       local mkfs_cmd=""
+       local mkfs_filter=""
+       local mkfs_status
+
+       case $FSTYP in
+       nfs*|cifs|ceph|overlay|glusterfs|pvfs2|9p)
+               # unable to re-create this fstyp, just remove all files in
+               # $SCRATCH_MNT to avoid EEXIST caused by the leftover files
+               # created in previous runs
+               _scratch_cleanup_files
+               return $?
+               ;;
+       tmpfs)
+               # do nothing for tmpfs
+               return 0
+               ;;
+       ubifs)
+               # erase the UBI volume; reformated automatically on next mount
+               $UBIUPDATEVOL_PROG ${SCRATCH_DEV} -t
+               return 0
+               ;;
+       ext4)
+               _scratch_mkfs_ext4 $*
+               return $?
+               ;;
+       xfs)
+               _scratch_mkfs_xfs $*
+               return $?
+               ;;
+       udf)
+               mkfs_cmd="$MKFS_UDF_PROG"
+               mkfs_filter="cat"
+               ;;
+       btrfs)
+               mkfs_cmd="$MKFS_BTRFS_PROG"
+               mkfs_filter="cat"
+               ;;
+       ext3)
+               mkfs_cmd="$MKFS_PROG -t $FSTYP -- -F"
+               mkfs_filter="grep -v -e ^Warning: -e \"^mke2fs \""
+
+               # put journal on separate device?
+               [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
+               $mkfs_cmd -O journal_dev $MKFS_OPTIONS $SCRATCH_LOGDEV && \
+               mkfs_cmd="$mkfs_cmd -J device=$SCRATCH_LOGDEV"
+               ;;
+       ext2)
+               mkfs_cmd="$MKFS_PROG -t $FSTYP -- -F"
+               mkfs_filter="grep -v -e ^Warning: -e \"^mke2fs \""
+               ;;
+       f2fs)
+               mkfs_cmd="$MKFS_F2FS_PROG"
+               mkfs_filter="cat"
+               ;;
+       ocfs2)
+               mkfs_cmd="yes | $MKFS_PROG -t $FSTYP --"
+               mkfs_filter="grep -v -e ^mkfs\.ocfs2"
+               ;;
+       *)
+               mkfs_cmd="yes | $MKFS_PROG -t $FSTYP --"
+               mkfs_filter="cat"
+               ;;
+       esac
+
+       _scratch_do_mkfs "$mkfs_cmd" "$mkfs_filter" $*
+       return $?
 }
 
 # Helper function to get a spare or replace-target device from
@@ -700,7 +826,7 @@ _spare_dev_get()
                _notrun "All devs used no spare"
        fi
        # Get a dev that is not used
-       local devs[]="( $SCRATCH_DEV_POOL_SAVED )"
+       local -a devs="( $SCRATCH_DEV_POOL_SAVED )"
        SPARE_DEV=${devs[@]:$ndevs:1}
        export SPARE_DEV
 }
@@ -742,7 +868,7 @@ _scratch_dev_pool_get()
 
        local test_ndevs=$1
        local config_ndevs=`echo $SCRATCH_DEV_POOL| wc -w`
-       local devs[]="( $SCRATCH_DEV_POOL )"
+       local -a devs="( $SCRATCH_DEV_POOL )"
 
        typeset -p config_ndevs >/dev/null 2>&1
        if [ $? -ne 0 ]; then
@@ -802,23 +928,27 @@ _free_memory_bytes()
 # _scratch_mkfs_sized <size in bytes> [optional blocksize]
 _scratch_mkfs_sized()
 {
-    fssize=$1
-    blocksize=$2
+    local fssize=$1
+    local blocksize=$2
+    local def_blksz
 
     case $FSTYP in
     xfs)
        def_blksz=`echo $MKFS_OPTIONS|sed -rn 's/.*-b ?size= ?+([0-9]+).*/\1/p'`
        ;;
-    ext2|ext3|ext4|ext4dev|udf|btrfs|reiser4|ocfs2)
+    ext2|ext3|ext4|ext4dev|udf|btrfs|reiser4|ocfs2|reiserfs)
        def_blksz=`echo $MKFS_OPTIONS| sed -rn 's/.*-b ?+([0-9]+).*/\1/p'`
        ;;
+    jfs)
+       def_blksz=4096
+       ;;
     esac
 
     [ -n "$def_blksz" ] && blocksize=$def_blksz
     [ -z "$blocksize" ] && blocksize=4096
 
 
-    re='^[0-9]+$'
+    local re='^[0-9]+$'
     if ! [[ $fssize =~ $re ]] ; then
         _notrun "error: _scratch_mkfs_sized: fs size \"$fssize\" not an integer."
     fi
@@ -826,10 +956,10 @@ _scratch_mkfs_sized()
         _notrun "error: _scratch_mkfs_sized: block size \"$blocksize\" not an integer."
     fi
 
-    blocks=`expr $fssize / $blocksize`
+    local blocks=`expr $fssize / $blocksize`
 
     if [ "$HOSTOS" == "Linux" -a -b "$SCRATCH_DEV" ]; then
-       devsize=`blockdev --getsize64 $SCRATCH_DEV`
+       local devsize=`blockdev --getsize64 $SCRATCH_DEV`
        [ "$fssize" -gt "$devsize" ] && _notrun "Scratch device too small"
     fi
 
@@ -846,6 +976,21 @@ _scratch_mkfs_sized()
     ext2|ext3|ext4|ext4dev)
        ${MKFS_PROG}.$FSTYP -F $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV $blocks
        ;;
+    gfs2)
+       # mkfs.gfs2 doesn't automatically shrink journal files on small
+       # filesystems, so the journal files may end up being bigger than the
+       # filesystem, which will cause mkfs.gfs2 to fail.  Until that's fixed,
+       # shrink the journal size to at most one eigth of the filesystem and at
+       # least 8 MiB, the minimum size allowed.
+       local min_journal_size=8
+       local default_journal_size=128
+       if (( fssize/8 / (1024*1024) < default_journal_size )); then
+           local journal_size=$(( fssize/8 / (1024*1024) ))
+           (( journal_size >= min_journal_size )) || journal_size=$min_journal_size
+           MKFS_OPTIONS="-J $journal_size $MKFS_OPTIONS"
+       fi
+       ${MKFS_PROG}.$FSTYP $MKFS_OPTIONS -O -b $blocksize $SCRATCH_DEV $blocks
+       ;;
     ocfs2)
        yes | ${MKFS_PROG}.$FSTYP -F $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV $blocks
        ;;
@@ -854,9 +999,15 @@ _scratch_mkfs_sized()
        ;;
     btrfs)
        local mixed_opt=
-       (( fssize <= 100 * 1024 * 1024 )) && mixed_opt='--mixed'
+       (( fssize <= 1024 * 1024 * 1024 )) && mixed_opt='--mixed'
        $MKFS_BTRFS_PROG $MKFS_OPTIONS $mixed_opt -b $fssize $SCRATCH_DEV
        ;;
+    jfs)
+       ${MKFS_PROG}.$FSTYP $MKFS_OPTIONS $SCRATCH_DEV $blocks
+       ;;
+    reiserfs)
+       ${MKFS_PROG}.$FSTYP $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV $blocks
+       ;;
     reiser4)
        # mkfs.resier4 requires size in KB as input for creating filesystem
        $MKFS_REISER4_PROG $MKFS_OPTIONS -y -b $blocksize $SCRATCH_DEV \
@@ -864,11 +1015,11 @@ _scratch_mkfs_sized()
        ;;
     f2fs)
        # mkfs.f2fs requires # of sectors as an input for the size
-       sector_size=`blockdev --getss $SCRATCH_DEV`
+       local sector_size=`blockdev --getss $SCRATCH_DEV`
        $MKFS_F2FS_PROG $MKFS_OPTIONS $SCRATCH_DEV `expr $fssize / $sector_size`
        ;;
     tmpfs)
-       free_mem=`_free_memory_bytes`
+       local free_mem=`_free_memory_bytes`
        if [ "$free_mem" -lt "$fssize" ] ; then
           _notrun "Not enough memory ($free_mem) for tmpfs with $fssize bytes"
        fi
@@ -884,13 +1035,13 @@ _scratch_mkfs_sized()
 # _scratch_mkfs_geom <sunit bytes> <swidth multiplier> [optional blocksize]
 _scratch_mkfs_geom()
 {
-    sunit_bytes=$1
-    swidth_mult=$2
-    blocksize=$3
+    local sunit_bytes=$1
+    local swidth_mult=$2
+    local blocksize=$3
     [ -z "$blocksize" ] && blocksize=4096
 
-    let sunit_blocks=$sunit_bytes/$blocksize
-    let swidth_blocks=$sunit_blocks*$swidth_mult
+    local sunit_blocks=$(( sunit_bytes / blocksize ))
+    local swidth_blocks=$(( sunit_blocks * swidth_mult ))
 
     case $FSTYP in
     xfs)
@@ -910,9 +1061,9 @@ _scratch_mkfs_geom()
 # _scratch_mkfs_blocksized blocksize
 _scratch_mkfs_blocksized()
 {
-    blocksize=$1
+    local blocksize=$1
 
-    re='^[0-9]+$'
+    local re='^[0-9]+$'
     if ! [[ $blocksize =~ $re ]] ; then
         _notrun "error: _scratch_mkfs_sized: block size \"$blocksize\" not an integer."
     fi
@@ -924,8 +1075,11 @@ _scratch_mkfs_blocksized()
     ext2|ext3|ext4)
        ${MKFS_PROG}.$FSTYP -F $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV
        ;;
+    gfs2)
+       ${MKFS_PROG}.$FSTYP $MKFS_OPTIONS -O -b $blocksize $SCRATCH_DEV
+       ;;
     ocfs2)
-       yes | ${MKFS_PROG}.$FSTYP -F $MKFS_OPTIONS -b $blocksize $SCRATCH_DEV
+       yes | ${MKFS_PROG}.$FSTYP -F $MKFS_OPTIONS -b $blocksize -C $blocksize $SCRATCH_DEV
        ;;
     *)
        _notrun "Filesystem $FSTYP not supported in _scratch_mkfs_blocksized"
@@ -953,10 +1107,10 @@ _repair_scratch_fs()
     case $FSTYP in
     xfs)
         _scratch_xfs_repair "$@" 2>&1
-       res=$?
+       local res=$?
        if [ "$res" -ne 0 ]; then
                echo "xfs_repair returns $res; replay log?"
-               _scratch_mount
+               _try_scratch_mount
                res=$?
                if [ "$res" -gt 0 ]; then
                        echo "mount returns $res; zap log?"
@@ -968,19 +1122,21 @@ _repair_scratch_fs()
                _scratch_xfs_repair "$@" 2>&1
                res=$?
        fi
-       test $res -ne 0 && >&2 echo "xfs_repair failed, err=$res"
+       if [ $res -ne 0 ]; then
+               _dump_err2 "xfs_repair failed, err=$res"
+       fi
        return $res
         ;;
     *)
         # Let's hope fsck -y suffices...
         fsck -t $FSTYP -y $SCRATCH_DEV 2>&1
-       res=$?
+       local res=$?
        case $res in
        0|1|2)
                res=0
                ;;
        *)
-               >&2 echo "fsck.$FSTYP failed, err=$res"
+               _dump_err2 "fsck.$FSTYP failed, err=$res"
                ;;
        esac
        return $res
@@ -1013,27 +1169,6 @@ _get_pids_by_name()
        -e "/[0-9]:[0-9][0-9]  *$1 /s/ .*//p"
 }
 
-# fix malloc libs output
-#
-_fix_malloc()
-{
-    # filter out the Electric Fence notice
-    $PERL_PROG -e '
-        while (<>) {
-            if (defined $o && /^\s+Electric Fence/) {
-                chomp($o);
-                print "$o";
-                undef $o;
-                next;
-            }
-            print $o if (defined $o);
-
-            $o=$_;
-        }
-        print $o if (defined $o);
-    '
-}
-
 #
 # _df_device : get an IRIX style df line for a given device
 #
@@ -1128,7 +1263,8 @@ _fs_type()
     # Fix the filesystem type up here so that the callers don't
     # have to bother with this quirk.
     #
-    _df_device $1 | $AWK_PROG '{ print $2 }' | sed -e 's/nfs4/nfs/'
+    _df_device $1 | $AWK_PROG '{ print $2 }' | \
+        sed -e 's/nfs4/nfs/' -e 's/fuse.glusterfs/glusterfs/'
 }
 
 # return the FS mount options of a mounted device
@@ -1160,16 +1296,35 @@ _is_block_dev()
        exit 1
     fi
 
-    _dev=$1
-    if [ -L "${_dev}" ]; then
-        _dev=`readlink -f "${_dev}"`
+    local dev=$1
+    if [ -L "$dev" ]; then
+        dev=`readlink -f "$dev"`
     fi
 
-    if [ -b "${_dev}" ]; then
-        src/lstat64 "${_dev}" | $AWK_PROG '/Device type:/ { print $9 }'
+    if [ -b "$dev" ]; then
+        src/lstat64 "$dev" | $AWK_PROG '/Device type:/ { print $9 }'
     fi
 }
 
+# returns device number if a file is a character device
+#
+_is_char_dev()
+{
+       if [ $# -ne 1 ]; then
+               echo "Usage: _is_char_dev dev" 1>&2
+               exit 1
+       fi
+
+       local dev=$1
+       if [ -L "$dev" ]; then
+               dev=`readlink -f "$dev"`
+       fi
+
+       if [ -c "$dev" ]; then
+               src/lstat64 "$dev" | $AWK_PROG '/Device type:/ { print $9 }'
+       fi
+}
+
 # Do a command, log it to $seqres.full, optionally test return status
 # and die if command fails. If called with one argument _do executes the
 # command, logs it, and returns its exit status. With two arguments _do
@@ -1183,19 +1338,21 @@ _is_block_dev()
 _do()
 {
     if [ $# -eq 1 ]; then
-       _cmd=$1
+       local cmd=$1
     elif [ $# -eq 2 ]; then
-       _note=$1
-       _cmd=$2
-       echo -n "$_note... "
+       local note=$1
+       local cmd=$2
+       echo -n "$note... "
     else
        echo "Usage: _do [note] cmd" 1>&2
        status=1; exit
     fi
 
-    (eval "echo '---' \"$_cmd\"") >>$seqres.full
-    (eval "$_cmd") >$tmp._out 2>&1; ret=$?
-    cat $tmp._out | _fix_malloc >>$seqres.full
+    (eval "echo '---' \"$cmd\"") >>$seqres.full
+    (eval "$cmd") >$tmp._out 2>&1
+    local ret=$?
+    cat $tmp._out >>$seqres.full
+    rm -f $tmp._out
     if [ $# -eq 2 ]; then
        if [ $ret -eq 0 ]; then
            echo "done"
@@ -1208,7 +1365,7 @@ _do()
            -o \( $# -eq 2 -a "$_do_die_on_error" = "message_only" \) ]
     then
        [ $# -ne 2 ] && echo
-       eval "echo \"$_cmd\" failed \(returned $ret\): see $seqres.full"
+       eval "echo \"$cmd\" failed \(returned $ret\): see $seqres.full"
        status=1; exit
     fi
 
@@ -1243,6 +1400,8 @@ _fail()
 #
 _supported_fs()
 {
+    local f
+
     for f
     do
        if [ "$f" = "$FSTYP" -o "$f" = "generic" ]
@@ -1259,6 +1418,8 @@ _supported_fs()
 #
 _supported_os()
 {
+    local h
+
     for h
     do
        if [ "$h" = "$HOSTOS" ]
@@ -1270,12 +1431,63 @@ _supported_os()
     _notrun "not suitable for this OS: $HOSTOS"
 }
 
+# check if a FS on a device is mounted
+# if so, verify that it is mounted on mount point
+# if fstype is given as argument, verify that it is also
+# mounted with correct fs type
+#
+_check_mounted_on()
+{
+       local devname=$1
+       local dev=$2
+       local mntname=$3
+       local mnt=$4
+       local type=$5
+
+       # find $dev as the source, and print result in "$dev $mnt" format
+       local mount_rec=`findmnt -rncv -S $dev -o SOURCE,TARGET`
+       [ -n "$mount_rec" ] || return 1 # 1 = not mounted
+
+       # if it's mounted, make sure its on $mnt
+       if [ "$mount_rec" != "$dev $mnt" ]; then
+               echo "$devname=$dev is mounted but not on $mntname=$mnt - aborting"
+               echo "Already mounted result:"
+               echo $mount_rec
+               return 2 # 2 = mounted on wrong mnt
+       fi
+
+       if [ -n "$type" -a "`_fs_type $dev`" != "$type" ]; then
+               echo "$devname=$dev is mounted but not a type $type filesystem"
+               # raw $DF_PROG cannot handle NFS/CIFS/overlay correctly
+               _df_device $dev
+               return 3 # 3 = mounted as wrong type
+       fi
+       return 0 # 0 = mounted as expected
+}
+
 # this test needs a scratch partition - check we're ok & unmount it
 # No post-test check of the device is required. e.g. the test intentionally
 # finishes the test with the filesystem in a corrupt state
 _require_scratch_nocheck()
 {
     case "$FSTYP" in
+       glusterfs)
+               echo $SCRATCH_DEV | egrep -q ":/?" > /dev/null 2>&1
+               if [ -z "$SCRATCH_DEV" -o "$?" != "0" ]; then
+                       _notrun "this test requires a valid \$SCRATCH_DEV"
+               fi
+               if [ ! -d "$SCRATCH_MNT" ]; then
+                       _notrun "this test requires a valid \$SCRATCH_MNT"
+               fi
+               ;;
+       9p)
+               if [ -z "$SCRATCH_DEV" ]; then
+                       _notrun "this test requires a valid \$SCRATCH_DEV"
+               fi
+               if [ ! -d "$SCRATCH_MNT" ]; then
+                       _notrun "this test requires a valid \$SCRATCH_MNT"
+               fi
+               ;;
        nfs*|ceph)
                echo $SCRATCH_DEV | grep -q ":/" > /dev/null 2>&1
                if [ -z "$SCRATCH_DEV" -o "$?" != "0" ]; then
@@ -1285,6 +1497,15 @@ _require_scratch_nocheck()
                        _notrun "this test requires a valid \$SCRATCH_MNT"
                fi
                ;;
+       pvfs2)
+               echo $SCRATCH_DEV | grep -q "://" > /dev/null 2>&1
+               if [ -z "$SCRATCH_DEV" -o "$?" != "0" ]; then
+                       _notrun "this test requires a valid \$SCRATCH_DEV"
+               fi
+               if [ ! -d "$SCRATCH_MNT" ]; then
+                       _notrun "this test requires a valid \$SCRATCH_MNT"
+               fi
+               ;;
        cifs)
                echo $SCRATCH_DEV | grep -q "//" > /dev/null 2>&1
                if [ -z "$SCRATCH_DEV" -o "$?" != "0" ]; then
@@ -1295,10 +1516,13 @@ _require_scratch_nocheck()
                fi
                ;;
        overlay)
-               if [ -z "$SCRATCH_DEV" -o ! -d "$SCRATCH_DEV" ]; then
-                       _notrun "this test requires a valid \$SCRATCH_DEV as ovl base dir"
+               if [ -z "$OVL_BASE_SCRATCH_MNT" -o ! -d "$OVL_BASE_SCRATCH_MNT" ]; then
+                       _notrun "this test requires a valid \$OVL_BASE_SCRATCH_MNT as ovl base dir"
                fi
-               if [ ! -d "$SCRATCH_MNT" ]; then
+               # if $SCRATCH_MNT is derived from $OVL_BASE_SCRATCH_MNT then
+               # don't check $SCRATCH_MNT dir here because base fs may not be mounted
+               # and we will create the mount point anyway on _overlay_mount
+               if [ "$SCRATCH_MNT" != "$OVL_BASE_SCRATCH_MNT/$OVL_MNT" -a ! -d "$SCRATCH_MNT" ]; then
                        _notrun "this test requires a valid \$SCRATCH_MNT"
                fi
                ;;
@@ -1308,6 +1532,15 @@ _require_scratch_nocheck()
                    _notrun "this test requires a valid \$SCRATCH_MNT and unique $SCRATCH_DEV"
                fi
                ;;
+       ubifs)
+               # ubifs needs an UBI volume. This will be a char device, not a block device.
+               if [ ! -c "$SCRATCH_DEV" ]; then
+                       _notrun "this test requires a valid UBI volume for \$SCRATCH_DEV"
+               fi
+               if [ ! -d "$SCRATCH_MNT" ]; then
+                       _notrun "this test requires a valid \$SCRATCH_MNT"
+               fi
+               ;;
        *)
                 if [ -z "$SCRATCH_DEV" -o "`_is_block_dev "$SCRATCH_DEV"`" = "" ]
                 then
@@ -1324,21 +1557,12 @@ _require_scratch_nocheck()
                 ;;
     esac
 
-    # mounted?
-    # Note that we use -F here so grep doesn't try to interpret an NFS over
-    # IPv6 server as a regular expression.
-    mount_rec=`_mount | grep -F $SCRATCH_DEV`
-    if [ "$mount_rec" ]
+    _check_mounted_on SCRATCH_DEV $SCRATCH_DEV SCRATCH_MNT $SCRATCH_MNT
+    local err=$?
+    [ $err -le 1 ] || exit 1
+    if [ $err -eq 0 ]
     then
-        # if it's mounted, make sure its on $SCRATCH_MNT
-        if ! echo $mount_rec | grep -q $SCRATCH_MNT
-        then
-            echo "\$SCRATCH_DEV=$SCRATCH_DEV is mounted but not on \$SCRATCH_MNT=$SCRATCH_MNT - aborting"
-            echo "Already mounted result:"
-            echo $mount_rec
-            exit 1
-        fi
-        # and then unmount it
+        # if it's mounted, unmount it
         if ! _scratch_unmount
         then
             echo "failed to unmount $SCRATCH_DEV"
@@ -1355,12 +1579,39 @@ _require_scratch()
        touch ${RESULT_DIR}/require_scratch
 }
 
+# require a scratch dev of a minimum size (in kb)
+_require_scratch_size()
+{
+       [ $# -eq 1 ] || _fail "_require_scratch_size: expected size param"
+
+       _require_scratch
+       local devsize=`_get_device_size $SCRATCH_DEV`
+       [ $devsize -lt $1 ] && _notrun "scratch dev too small"
+}
+
 
 # this test needs a test partition - check we're ok & mount it
 #
 _require_test()
 {
     case "$FSTYP" in
+       glusterfs)
+               echo $TEST_DEV | egrep -q ":/?" > /dev/null 2>&1
+               if [ -z "$TEST_DEV" -o "$?" != "0" ]; then
+                       _notrun "this test requires a valid \$TEST_DEV"
+               fi
+               if [ ! -d "$TEST_DIR" ]; then
+                       _notrun "this test requires a valid \$TEST_DIR"
+               fi
+               ;;
+       9p)
+               if [ -z "$TEST_DEV" ]; then
+                       _notrun "this test requires a valid \$TEST_DEV"
+               fi
+               if [ ! -d "$TEST_DIR" ]; then
+                       _notrun "this test requires a valid \$TEST_DIR"
+               fi
+               ;;
        nfs*|ceph)
                echo $TEST_DEV | grep -q ":/" > /dev/null 2>&1
                if [ -z "$TEST_DEV" -o "$?" != "0" ]; then
@@ -1379,9 +1630,18 @@ _require_test()
                     _notrun "this test requires a valid \$TEST_DIR"
                fi
                ;;
+       pvfs2)
+               echo $TEST_DEV | grep -q "://" > /dev/null 2>&1
+               if [ -z "$TEST_DEV" -o "$?" != "0" ]; then
+                       _notrun "this test requires a valid \$TEST_DIR"
+               fi
+               if [ ! -d "$TEST_DIR" ]; then
+                       _notrun "this test requires a valid \$TEST_DIR"
+               fi
+               ;;
        overlay)
-               if [ -z "$TEST_DEV" -o ! -d "$TEST_DEV" ]; then
-                       _notrun "this test requires a valid \$TEST_DEV as ovl base dir"
+               if [ -z "$OVL_BASE_TEST_DIR" -o ! -d "$OVL_BASE_TEST_DIR" ]; then
+                       _notrun "this test requires a valid \$TEST_DIR as ovl base dir"
                fi
                if [ ! -d "$TEST_DIR" ]; then
                        _notrun "this test requires a valid \$TEST_DIR"
@@ -1393,6 +1653,15 @@ _require_test()
                    _notrun "this test requires a valid \$TEST_DIR and unique $TEST_DEV"
                fi
                ;;
+       ubifs)
+               # ubifs needs an UBI volume. This will be a char device, not a block device.
+               if [ ! -c "$TEST_DEV" ]; then
+                       _notrun "this test requires a valid UBI volume for \$TEST_DEV"
+               fi
+               if [ ! -d "$TEST_DIR" ]; then
+                       _notrun "this test requires a valid \$TEST_DIR"
+               fi
+               ;;
        *)
                 if [ -z "$TEST_DEV" ] || [ "`_is_block_dev "$TEST_DEV"`" = "" ]
                 then
@@ -1409,30 +1678,29 @@ _require_test()
                 ;;
     esac
 
-    # mounted?
-    # Note that we use -F here so grep doesn't try to interpret an NFS over
-    # IPv6 server as a regular expression.
-    mount_rec=`_mount | grep -F $TEST_DEV`
-    if [ "$mount_rec" ]
+    _check_mounted_on TEST_DEV $TEST_DEV TEST_DIR $TEST_DIR
+    local err=$?
+    [ $err -le 1 ] || exit 1
+    if [ $err -ne 0 ]
     then
-        # if it's mounted, make sure its on $TEST_DIR
-        if ! echo $mount_rec | grep -q $TEST_DIR
-        then
-            echo "\$TEST_DEV=$TEST_DEV is mounted but not on \$TEST_DIR=$TEST_DIR - aborting"
-            echo "Already mounted result:"
-            echo $mount_rec
-            exit 1
-        fi
-    else
-       out=`_mount_or_remount_rw "$MOUNT_OPTIONS" $TEST_DEV $TEST_DIR`
-       if [ $? -ne 1 ]; then
-               echo $out
+       if ! _test_mount
+       then
+               echo "!!! failed to mount $TEST_DEV on $TEST_DIR"
                exit 1
        fi
     fi
     touch ${RESULT_DIR}/require_test
 }
 
+_has_logdev()
+{
+       local ret=0
+       [ -z "$SCRATCH_LOGDEV" -o ! -b "$SCRATCH_LOGDEV" ] && ret=1
+       [ "$USE_EXTERNAL" != yes ] && ret=1
+
+       return $ret
+}
+
 # this test needs a logdev
 #
 _require_logdev()
@@ -1482,6 +1750,15 @@ _require_ext2()
     fi
 }
 
+# this test requires tmpfs filesystem support
+#
+_require_tmpfs()
+{
+       modprobe tmpfs >/dev/null 2>&1
+       grep -q tmpfs /proc/filesystems ||
+               _notrun "this test requires tmpfs support"
+}
+
 # this test requires that (large) loopback device files are not in use
 #
 _require_no_large_scratch_dev()
@@ -1501,6 +1778,14 @@ _require_realtime()
        _notrun "Realtime device required, skipped this test"
 }
 
+# This test requires that a realtime subvolume is not in use
+#
+_require_no_realtime()
+{
+       [ "$USE_EXTERNAL" = "yes" ] && [ -n "$SCRATCH_RTDEV" ] && \
+               _notrun "Test not compatible with realtime subvolumes, skipped this test"
+}
+
 # this test requires that a specified command (executable) exists
 # $1 - command, $2 - name for error message
 #
@@ -1509,16 +1794,16 @@ _require_realtime()
 _require_command()
 {
        if [ $# -eq 2 ]; then
-               _name="$2"
+               local name="$2"
        elif [ $# -eq 1 ]; then
-               _name="$1"
+               local name="$1"
        else
                _fail "usage: _require_command <command> [<name>]"
        fi
 
-       _command=`echo "$1" | awk '{ print $1 }'`
-       if [ ! -x "$_command" ]; then
-               _notrun "$_name utility required, skipped this test"
+       local command=`echo "$1" | awk '{ print $1 }'`
+       if [ ! -x "$command" ]; then
+               _notrun "$name utility required, skipped this test"
        fi
 }
 
@@ -1535,6 +1820,23 @@ _require_block_device()
        fi
 }
 
+# this test requires a path to refere to a local block or character device
+# $1 - device
+_require_local_device()
+{
+       if [ -z "$1" ]; then
+               echo "Usage: _require_local_device <dev>" 1>&2
+               exit 1
+       fi
+       if [ "`_is_block_dev "$1"`" != "" ]; then
+               return 0
+       fi
+       if [ "`_is_char_dev "$1"`" != "" ]; then
+               return 0
+       fi
+       _notrun "require $1 to be local device"
+}
+
 # brd based ram disks erase the device when they receive a flush command when no
 # active references are present. This causes problems for DM devices sitting on
 # top of brd devices as DM doesn't hold active references to the brd device.
@@ -1549,7 +1851,7 @@ _require_sane_bdev_flush()
 # this test requires a specific device mapper target
 _require_dm_target()
 {
-       _target=$1
+       local target=$1
 
        # require SCRATCH_DEV to be a valid block device with sane BLKFLSBUF
        # behaviour
@@ -1557,11 +1859,11 @@ _require_dm_target()
        _require_sane_bdev_flush $SCRATCH_DEV
        _require_command "$DMSETUP_PROG" dmsetup
 
-       modprobe dm-$_target >/dev/null 2>&1
+       modprobe dm-$target >/dev/null 2>&1
 
-       $DMSETUP_PROG targets 2>&1 | grep -q ^$_target
+       $DMSETUP_PROG targets 2>&1 | grep -q ^$target
        if [ $? -ne 0 ]; then
-               _notrun "This test requires dm $_target support"
+               _notrun "This test requires dm $target support"
        fi
 }
 
@@ -1571,27 +1873,25 @@ _require_scratch_ext4_crc()
 {
        _scratch_mkfs_ext4 >/dev/null 2>&1
        dumpe2fs -h $SCRATCH_DEV 2> /dev/null | grep -q metadata_csum || _notrun "metadata_csum not supported by this filesystem"
-       _scratch_mount >/dev/null 2>&1 \
+       _try_scratch_mount >/dev/null 2>&1 \
           || _notrun "Kernel doesn't support metadata_csum feature"
        _scratch_unmount
 }
 
-# this test requires the bigalloc feature to be available in mkfs.ext4
-#
-_require_ext4_mkfs_bigalloc()
-{
-       $MKFS_EXT4_PROG -F -O bigalloc -n $SCRATCH_DEV 512m >/dev/null 2>&1 \
-          || _notrun "mkfs.ext4 doesn't have bigalloc feature"
-}
-
-# this test requires the ext4 kernel support bigalloc feature
-#
-_require_ext4_bigalloc()
+# Check whether the specified feature whether it is supported by
+# mkfs.ext4 and the kernel.
+_require_scratch_ext4_feature()
 {
-       $MKFS_EXT4_PROG -F -O bigalloc $SCRATCH_DEV 512m >/dev/null 2>&1
-       _scratch_mount >/dev/null 2>&1 \
-          || _notrun "Ext4 kernel doesn't support bigalloc feature"
-       _scratch_unmount
+    if [ -z "$1" ]; then
+        echo "Usage: _require_scratch_ext4_feature feature"
+        exit 1
+    fi
+    $MKFS_EXT4_PROG -F $MKFS_OPTIONS -O "$1" \
+                   $SCRATCH_DEV 512m >/dev/null 2>&1 \
+       || _notrun "mkfs.ext4 doesn't support $1 feature"
+    _try_scratch_mount >/dev/null 2>&1 \
+       || _notrun "Kernel doesn't support the ext4 feature(s): $1"
+    _scratch_unmount
 }
 
 # this test requires that external log/realtime devices are not in use
@@ -1602,7 +1902,24 @@ _require_nonexternal()
        _notrun "External device testing in progress, skipped this test"
 }
 
+# this test requires that the kernel supports asynchronous I/O
+_require_aio()
+{
+       $here/src/feature -A
+       case $? in
+       0)
+               ;;
+       1)
+               _notrun "kernel does not support asynchronous I/O"
+               ;;
+       *)
+               _fail "unexpected error testing for asynchronous I/O support"
+               ;;
+       esac
+}
+
 # this test requires that a (specified) aio-dio executable exists
+# and that the kernel supports asynchronous I/O.
 # $1 - command (optional)
 #
 _require_aiodio()
@@ -1615,6 +1932,7 @@ _require_aiodio()
         AIO_TEST=src/aio-dio-regress/$1
         [ -x $AIO_TEST ] || _notrun "$AIO_TEST not built"
     fi
+    _require_aio
     _require_odirect
 }
 
@@ -1623,8 +1941,8 @@ _require_aiodio()
 #
 _require_test_program()
 {
-    SRC_TEST=src/$1
-    [ -x $SRC_TEST ] || _notrun "$SRC_TEST not built"
+    local prog=src/$1
+    [ -x $prog ] || _notrun "$prog not built"
 }
 
 # run an aio-dio program
@@ -1648,13 +1966,59 @@ _run_aiodio()
     return $status
 }
 
+# this test requires y2038 sysfs switch and filesystem
+# timestamp ranges support.
+_require_y2038()
+{
+       local device=${1:-$TEST_DEV}
+       local sysfsdir=/proc/sys/fs/fs-timestamp-check-on
+
+       if [ ! -e $sysfsdir ]; then
+               _notrun "no kernel support for y2038 sysfs switch"
+       fi
+
+       local tsmin tsmax
+       read tsmin tsmax <<<$(_filesystem_timestamp_range $device)
+       if [ $tsmin -eq -1 -a $tsmax -eq -1 ]; then
+               _notrun "filesystem $FSTYP timestamp bounds are unknown"
+       fi
+}
+
+_filesystem_timestamp_range()
+{
+       local device=${1:-$TEST_DEV}
+       case $FSTYP in
+       ext4)
+               if [ $(dumpe2fs -h $device 2>/dev/null | grep "Inode size:" | cut -d: -f2) -gt 128 ]; then
+                       echo "-2147483648 15032385535"
+               else
+                       echo "-2147483648 2147483647"
+               fi
+               ;;
+
+       xfs)
+               echo "-2147483648 2147483647"
+               ;;
+       jfs)
+               echo "0 4294967295"
+               ;;
+       f2fs)
+               echo "-2147483648 2147483647"
+               ;;
+       *)
+               echo "-1 -1"
+               ;;
+       esac
+}
+
 # indicate whether YP/NIS is active or not
 #
 _yp_active()
 {
        local dn
        dn=$(domainname 2>/dev/null)
-       test -n "${dn}" -a "${dn}" != "(none)"
+       local ypcat=$(type -P ypcat)
+       test -n "${dn}" -a "${dn}" != "(none)" -a "${dn}" != "localdomain" -a -n "${ypcat}"
        echo $?
 }
 
@@ -1697,7 +2061,7 @@ _require_group()
         qa_group=$1
     fi
     _cat_group | grep -q $qa_group
-    [ "$?" == "0" ] || _notrun "$qa_group user not defined."
+    [ "$?" == "0" ] || _notrun "$qa_group group not defined."
 }
 
 _filter_user_do()
@@ -1712,12 +2076,7 @@ s,^\s*$,,;
 
 _user_do()
 {
-    if [ "$HOSTOS" == "IRIX" ]
-       then
-       echo $1 | /bin/bash "su $qa_user 2>&1" | _filter_user_do
-    else
-       echo $1 | su $qa_user 2>&1 | _filter_user_do
-    fi
+       echo $1 | su -s /bin/bash $qa_user 2>&1 | _filter_user_do
 }
 
 _require_xfs_io_command()
@@ -1727,25 +2086,45 @@ _require_xfs_io_command()
                echo "Usage: _require_xfs_io_command command [switch]" 1>&2
                exit 1
        fi
-       command=$1
+       local command=$1
        shift
-       param="$*"
+       local param="$*"
+       local param_checked=0
+       local opts=""
 
-       testfile=$TEST_DIR/$$.xfs_io
+       local testfile=$TEST_DIR/$$.xfs_io
+       local testio
        case $command in
        "chproj")
                testio=`$XFS_IO_PROG -F -f -c "chproj 0" $testfile 2>&1`
                ;;
+       "copy_range")
+               local testcopy=$TEST_DIR/$$.copy.xfs_io
+               $XFS_IO_PROG -F -f -c "pwrite 0 4k" $testfile > /dev/null 2>&1
+               testio=`$XFS_IO_PROG -F -f -c "copy_range $testfile" $testcopy 2>&1`
+               rm -f $testcopy > /dev/null 2>&1
+               ;;
        "falloc" )
-               testio=`$XFS_IO_PROG -F -f -c "falloc 0 1m" $testfile 2>&1`
+               testio=`$XFS_IO_PROG -F -f -c "falloc $param 0 1m" $testfile 2>&1`
+               param_checked=1
                ;;
        "fpunch" | "fcollapse" | "zero" | "fzero" | "finsert" | "funshare")
-               testio=`$XFS_IO_PROG -F -f -c "pwrite 0 20k" -c "fsync" \
-                       -c "$command 4k 8k" $testfile 2>&1`
+               local blocksize=$(_get_block_size $TEST_DIR)
+               testio=`$XFS_IO_PROG -F -f -c "pwrite 0 $((5 * $blocksize))" \
+                       -c "fsync" -c "$command $blocksize $((2 * $blocksize))" \
+                       $testfile 2>&1`
                ;;
        "fiemap")
+               # If 'ranged' is passed as argument then we check to see if fiemap supports
+               # ranged query params
+               if echo "$param" | grep -q "ranged"; then
+                       param=$(echo "$param" | sed "s/ranged//")
+                       $XFS_IO_PROG -c "help fiemap" | grep -q "\[offset \[len\]\]"
+                       [ $? -eq 0 ] || _notrun "xfs_io $command ranged support is missing"
+               fi
                testio=`$XFS_IO_PROG -F -f -c "pwrite 0 20k" -c "fsync" \
-                       -c "fiemap -v" $testfile 2>&1`
+                       -c "fiemap -v $param" $testfile 2>&1`
+               param_checked=1
                ;;
        "flink" )
                testio=`$XFS_IO_PROG -T -F -c "flink $testfile" \
@@ -1755,7 +2134,7 @@ _require_xfs_io_command()
                ;;
        "fsmap" )
                testio=`$XFS_IO_PROG -f -c "fsmap" $testfile 2>&1`
-               echo $testio | egrep -q "Inappropriate ioctl" && \
+               echo $testio | grep -q "Inappropriate ioctl" && \
                        _notrun "xfs_io $command support is missing"
                ;;
        "open")
@@ -1763,11 +2142,34 @@ _require_xfs_io_command()
                # a new -C flag was introduced to execute one shot commands.
                # Check for -C flag support as an indication for the bug fix.
                testio=`$XFS_IO_PROG -F -f -C "open $testfile" $testfile 2>&1`
-               echo $testio | egrep -q "invalid option" && \
+               echo $testio | grep -q "invalid option" && \
+                       _notrun "xfs_io $command support is missing"
+               ;;
+       "pwrite")
+               # -N (RWF_NOWAIT) only works with direct vectored I/O writes
+               local pwrite_opts=" "
+               if [ "$param" == "-N" ]; then
+                       opts+=" -d"
+                       pwrite_opts+="-V 1 -b 4k"
+               fi
+               testio=`$XFS_IO_PROG -f $opts -c \
+                       "pwrite $pwrite_opts $param 0 4k" $testfile 2>&1`
+               param_checked=1
+               ;;
+       "scrub"|"repair")
+               testio=`$XFS_IO_PROG -x -c "$command probe 0" $TEST_DIR 2>&1`
+               echo $testio | grep -q "Inappropriate ioctl" && \
                        _notrun "xfs_io $command support is missing"
                ;;
+       "utimes" )
+               testio=`$XFS_IO_PROG -f -c "utimes" 0 0 0 0 $testfile 2>&1`
+               ;;
+       "syncfs")
+               touch $testfile
+               testio=`$XFS_IO_PROG -c "syncfs" $testfile 2>&1`
+               ;;
        *)
-               testio=`$XFS_IO_PROG -c "$command help" 2>&1`
+               testio=`$XFS_IO_PROG -c "help $command" 2>&1`
        esac
 
        rm -f $testfile 2>&1 > /dev/null
@@ -1775,12 +2177,24 @@ _require_xfs_io_command()
                _notrun "xfs_io $command support is missing"
        echo $testio | grep -q "Operation not supported" && \
                _notrun "xfs_io $command failed (old kernel/wrong fs?)"
+       echo $testio | grep -q "Invalid" && \
+               _notrun "xfs_io $command failed (old kernel/wrong fs/bad args?)"
        echo $testio | grep -q "foreign file active" && \
                _notrun "xfs_io $command not supported on $FSTYP"
+       echo $testio | grep -q "Function not implemented" && \
+               _notrun "xfs_io $command support is missing (missing syscall?)"
+
+       [ -n "$param" ] || return
 
-       test -z "$param" && return
-       $XFS_IO_PROG -c "help $command" | grep -q "^ $param --" || \
-               _notrun "xfs_io $command doesn't support $param"
+       if [ $param_checked -eq 0 ]; then
+               $XFS_IO_PROG -c "help $command" | grep -q "^ $param --" || \
+                       _notrun "xfs_io $command doesn't support $param"
+       else
+               # xfs_io could result in "command %c not supported" if it was
+               # built on kernels not supporting pwritev2() calls
+               echo $testio | grep -q "\(invalid option\|not supported\)" && \
+                       _notrun "xfs_io $command doesn't support $param"
+       fi
 }
 
 # check that kernel and filesystem support direct I/O
@@ -1789,9 +2203,11 @@ _require_odirect()
        if [ $FSTYP = "ext4" ] ; then
                if echo "$MOUNT_OPTIONS" | grep -q "test_dummy_encryption"; then
                        _notrun "ext4 encryption doesn't support O_DIRECT"
+               elif echo "$MOUNT_OPTIONS" | grep -q "data=journal"; then
+                       _notrun "ext4 data journaling doesn't support O_DIRECT"
                fi
        fi
-       testfile=$TEST_DIR/$$.direct
+       local testfile=$TEST_DIR/$$.direct
        $XFS_IO_PROG -F -f -d -c "pwrite 0 20k" $testfile > /dev/null 2>&1
        if [ $? -ne 0 ]; then
                _notrun "O_DIRECT is not supported"
@@ -1825,13 +2241,13 @@ _require_scratch_swapfile()
 #
 _require_fs_space()
 {
-       MNT=$1
-       BLOCKS=$2       # in units of 1024
-       let GB=$BLOCKS/1024/1024
+       local mnt=$1
+       local blocks=$2 # in units of 1024
+       local gb=$(( blocks / 1024 / 1024 ))
 
-       FREE_BLOCKS=`df -kP $MNT | grep -v Filesystem | awk '{print $4}'`
-       [ $FREE_BLOCKS -lt $BLOCKS ] && \
-               _notrun "This test requires at least ${GB}GB free on $MNT to run"
+       local free_blocks=`df -kP $mnt | grep -v Filesystem | awk '{print $4}'`
+       [ $free_blocks -lt $blocks ] && \
+               _notrun "This test requires at least ${gb}GB free on $mnt to run"
 }
 
 #
@@ -1863,16 +2279,31 @@ _require_fail_make_request()
  not found. Seems that CONFIG_FAIL_MAKE_REQUEST kernel config option not enabled"
 }
 
-#
+# Disable extent zeroing for ext4 on the given device
+_ext4_disable_extent_zeroout()
+{
+       local dev=${1:-$TEST_DEV}
+       local sdev=`_short_dev $dev`
+
+       [ -f /sys/fs/ext4/$sdev/extent_max_zeroout_kb ] && \
+               echo 0 >/sys/fs/ext4/$sdev/extent_max_zeroout_kb
+}
+
 # Check if the file system supports seek_data/hole
-#
 _require_seek_data_hole()
 {
-    testfile=$TEST_DIR/$$.seek
-    testseek=`$here/src/seek_sanity_test -t $testfile 2>&1`
-    rm -f $testfile &>/dev/null
-    echo $testseek | grep -q "Kernel does not support" && \
-        _notrun "File system does not support llseek(2) SEEK_DATA/HOLE"
+       local dev=${1:-$TEST_DEV}
+       local testfile=$TEST_DIR/$$.seek
+       local testseek=`$here/src/seek_sanity_test -t $testfile 2>&1`
+
+       rm -f $testfile &>/dev/null
+       echo $testseek | grep -q "Kernel does not support" && \
+               _notrun "File system does not support llseek(2) SEEK_DATA/HOLE"
+       # Disable extent zeroing for ext4 as that change where holes are
+       # created
+       if [ "$FSTYP" = "ext4" ]; then
+               _ext4_disable_extent_zeroout $dev
+       fi
 }
 
 _require_runas()
@@ -1896,7 +2327,7 @@ _require_scratch_richacl_xfs()
        _scratch_mkfs_xfs_supported -m richacl=1 >/dev/null 2>&1 \
                || _notrun "mkfs.xfs doesn't have richacl feature"
        _scratch_mkfs_xfs -m richacl=1 >/dev/null 2>&1
-       _scratch_mount >/dev/null 2>&1 \
+       _try_scratch_mount >/dev/null 2>&1 \
                || _notrun "kernel doesn't support richacl feature on $FSTYP"
        _scratch_unmount
 }
@@ -1905,7 +2336,7 @@ _require_scratch_richacl_ext4()
 {
        _scratch_mkfs -O richacl >/dev/null 2>&1 \
                || _notrun "can't mkfs $FSTYP with option -O richacl"
-       _scratch_mount >/dev/null 2>&1 \
+       _try_scratch_mount >/dev/null 2>&1 \
                || _notrun "kernel doesn't support richacl feature on $FSTYP"
        _scratch_unmount
 }
@@ -1946,27 +2377,32 @@ _scratch_mkfs_richacl()
        esac
 }
 
-# check that a FS on a device is mounted
-# if so, return mount point
-#
-_is_mounted()
+# check if the given device is mounted, if so, return mount point
+_is_dev_mounted()
 {
-    if [ $# -ne 1 ]
-    then
-       echo "Usage: _is_mounted device" 1>&2
-       exit 1
-    fi
+       local dev=$1
+       local fstype=${2:-$FSTYP}
 
-    device=$1
+       if [ $# -lt 1 ]; then
+               echo "Usage: _is_dev_mounted <device> [fstype]" 1>&2
+               exit 1
+       fi
 
-    if _mount | grep "$device " | $AWK_PROG -v pattern="type $FSTYP" '
-        pattern        { print $3 ; exit 0 }
-        END            { exit 1 }
-    '
-    then
-        echo "_is_mounted: $device is not a mounted $FSTYP FS"
-        exit 1
-    fi
+       findmnt -rncv -S $dev -t $fstype -o TARGET | head -1
+}
+
+# check if the given dir is a mount point, if so, return mount point
+_is_dir_mountpoint()
+{
+       local dir=$1
+       local fstype=${2:-$FSTYP}
+
+       if [ $# -lt 1 ]; then
+               echo "Uasge: _is_dir_mountpoint <dir> [fstype]" 1>&2
+               exit 1
+       fi
+
+       findmnt -rncv -t $fstype -o TARGET $dir | head -1
 }
 
 # remount a FS to a new mode (ro or rw)
@@ -1978,8 +2414,8 @@ _remount()
        echo "Usage: _remount device ro/rw" 1>&2
        exit 1
     fi
-    device=$1
-    mode=$2
+    local device=$1
+    local mode=$2
 
     if ! mount -o remount,$mode $device
     then
@@ -2005,8 +2441,8 @@ _umount_or_remount_ro()
        exit 1
     fi
 
-    device=$1
-    mountpoint=`_is_mounted $device`
+    local device=$1
+    local mountpoint=`_is_dev_mounted $device`
 
     if [ $USE_REMOUNT -eq 0 ]; then
         $UMOUNT_PROG $device
@@ -2022,9 +2458,9 @@ _mount_or_remount_rw()
                echo "Usage: _mount_or_remount_rw <opts> <dev> <mnt>" 1>&2
                exit 1
        fi
-       mount_opts=$1
-       device=$2
-       mountpoint=$3
+       local mount_opts=$1
+       local device=$2
+       local mountpoint=$3
 
        if [ $USE_REMOUNT -eq 0 ]; then
                if [ "$FSTYP" != "overlay" ]; then
@@ -2033,7 +2469,7 @@ _mount_or_remount_rw()
                        _overlay_mount $device $mountpoint
                fi
                if [ $? -ne 0 ]; then
-                       echo "!!! failed to remount $device on $mountpoint"
+                       _dump_err "!!! failed to remount $device on $mountpoint"
                        return 0 # ok=0
                fi
        else
@@ -2052,24 +2488,22 @@ _mount_or_remount_rw()
 #
 _check_generic_filesystem()
 {
-    device=$1
+    local device=$1
 
     # If type is set, we're mounted
-    type=`_fs_type $device`
-    ok=1
+    local type=`_fs_type $device`
+    local ok=1
 
     if [ "$type" = "$FSTYP" ]
     then
         # mounted ...
-        mountpoint=`_umount_or_remount_ro $device`
+        local mountpoint=`_umount_or_remount_ro $device`
     fi
 
     fsck -t $FSTYP $FSCK_OPTIONS $device >$tmp.fsck 2>&1
     if [ $? -ne 0 ]
     then
-        echo "_check_generic_filesystem: filesystem on $device is inconsistent (see $seqres.full)"
-
-        echo "_check_generic filesystem: filesystem on $device is inconsistent" >>$seqres.full
+       _log_err "_check_generic_filesystem: filesystem on $device is inconsistent"
         echo "*** fsck.$FSTYP output ***"      >>$seqres.full
         cat $tmp.fsck                          >>$seqres.full
         echo "*** end fsck.$FSTYP output"      >>$seqres.full
@@ -2128,16 +2562,15 @@ _check_udf_filesystem()
        return
     fi
 
-    device=$1
-    if [ $# -eq 2 ];
-    then
-        LAST_BLOCK=`expr \( $2 - 1 \)`
-        OPT_ARG="-lastvalidblock $LAST_BLOCK"
+    local device=$1
+    local opt_arg=""
+    if [ $# -eq 2 ]; then
+       opt_arg="-lastvalidblock $(( $2 - 1 ))"
     fi
 
     rm -f $seqres.checkfs
     sleep 1 # Due to a problem with time stamps in udf_test
-    $here/src/udf_test $OPT_ARG $device | tee $seqres.checkfs | egrep "Error|Warning" | \
+    $here/src/udf_test $opt_arg $device | tee $seqres.checkfs | egrep "Error|Warning" | \
        _udf_test_known_error_filter | \
        egrep -iv "Error count:.*[0-9]+.*total occurrences:.*[0-9]+|Warning count:.*[0-9]+.*total occurrences:.*[0-9]+" && \
         echo "Warning UDF Verifier reported errors see $seqres.checkfs." && return 1
@@ -2156,11 +2589,19 @@ _check_test_fs()
     cifs)
        # no way to check consistency for cifs
        ;;
+    9p)
+       # no way to check consistency for 9p
+       ;;
     ceph)
        # no way to check consistency for CephFS
        ;;
+    glusterfs)
+       # no way to check consistency for GlusterFS
+       ;;
     overlay)
-       # no way to check consistency for overlay
+       _check_overlay_test_fs
+       ;;
+    pvfs2)
        ;;
     udf)
        # do nothing for now
@@ -2171,6 +2612,9 @@ _check_test_fs()
     tmpfs)
        # no way to check consistency for tmpfs
        ;;
+    ubifs)
+       # there is no fsck program for ubifs yet
+       ;;
     *)
        _check_generic_filesystem $TEST_DEV
        ;;
@@ -2179,20 +2623,20 @@ _check_test_fs()
 
 _check_scratch_fs()
 {
-    device=$SCRATCH_DEV
+    local device=$SCRATCH_DEV
     [ $# -eq 1 ] && device=$1
 
     case $FSTYP in
     xfs)
-       SCRATCH_LOG="none"
-       SCRATCH_RT="none"
+       local scratch_log="none"
+       local scratch_rt="none"
        [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
-           SCRATCH_LOG="$SCRATCH_LOGDEV"
+           scratch_log="$SCRATCH_LOGDEV"
 
        [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_RTDEV" ] && \
-           SCRATCH_RT="$SCRATCH_RTDEV"
+           scratch_rt="$SCRATCH_RTDEV"
 
-       _check_xfs_filesystem $device $SCRATCH_LOG $SCRATCH_RT
+       _check_xfs_filesystem $device $scratch_log $scratch_rt
        ;;
     udf)
        _check_udf_filesystem $device $udf_fsize
@@ -2203,11 +2647,19 @@ _check_scratch_fs()
     cifs)
        # Don't know how to check a CIFS filesystem, yet.
        ;;
+    9p)
+       # no way to check consistency for 9p
+       ;;
     ceph)
        # no way to check consistency for CephFS
        ;;
+    glusterfs)
+       # no way to check consistency for GlusterFS
+       ;;
     overlay)
-       # no way to check consistency for overlay
+       _check_overlay_scratch_fs
+       ;;
+    pvfs2)
        ;;
     btrfs)
        _check_btrfs_filesystem $device
@@ -2215,6 +2667,9 @@ _check_scratch_fs()
     tmpfs)
        # no way to check consistency for tmpfs
        ;;
+    ubifs)
+       # there is no fsck program for ubifs yet
+       ;;
     *)
        _check_generic_filesystem $device
        ;;
@@ -2244,18 +2699,16 @@ _full_fstyp_details()
 
 _full_platform_details()
 {
-     os=`uname -s`
-     host=`hostname -s`
-     kernel=`uname -r`
-     platform=`uname -m`
+     local os=`uname -s`
+     local host=`hostname -s`
+     local kernel=`uname -r`
+     local platform=`uname -m`
      echo "$os/$platform $host $kernel"
 }
 
 _get_os_name()
 {
-       if [ "`uname`" == "IRIX64" ] || [ "`uname`" == "IRIX" ]; then
-               echo 'irix'
-       elif [ "`uname`" == "Linux" ]; then
+       if [ "`uname`" == "Linux" ]; then
                echo 'linux'
        else
                echo Unknown operating system: `uname`
@@ -2265,8 +2718,8 @@ _get_os_name()
 
 _link_out_file_named()
 {
-       export FEATURES=$2
-       SUFFIX=$(perl -e '
+       local features=$2
+       local suffix=$(FEATURES="$features" perl -e '
                my %feathash;
                my $feature, $result, $suffix, $opts;
 
@@ -2293,22 +2746,23 @@ _link_out_file_named()
                print $result
                ' <$seqfull.cfg)
        rm -f $1
-       SRC=$(basename $1)
-       ln -fs $SRC.$SUFFIX $1
+       ln -fs $(basename $1).$suffix $1
 }
 
 _link_out_file()
 {
+       local features
+
        if [ $# -eq 0 ]; then
-               FEATURES="$(_get_os_name)"
+               features="$(_get_os_name)"
                if [ -n "$MOUNT_OPTIONS" ]; then
-                       FEATURES=$FEATURES,${MOUNT_OPTIONS##"-o "}
+                       features=$features,${MOUNT_OPTIONS##"-o "}
                fi
        else
-               FEATURES=$1
+               features=$1
        fi
 
-       _link_out_file_named $seqfull.out "$FEATURES"
+       _link_out_file_named $seqfull.out "$features"
 }
 
 _die()
@@ -2317,17 +2771,25 @@ _die()
         exit 1
 }
 
+# convert urandom incompressible data to compressible text data
+_ddt()
+{
+       od /dev/urandom | dd iflag=fullblock ${*}
+}
+
 #takes files, randomdata
 _nfiles()
 {
-        f=0
+        local f=0
         while [ $f -lt $1 ]
         do
-                file=f$f
+                local file=f$f
                 echo > $file
                 if [ $size -gt 0 ]; then
                     if [ "$2" == "false" ]; then
                         dd if=/dev/zero of=$file bs=1024 count=$size 2>&1 | _filter_dd
+                    elif [ "$2" == "comp" ]; then
+                        _ddt of=$file bs=1024 count=$size 2>&1 | _filter_dd
                     else
                         dd if=/dev/urandom of=$file bs=1024 count=$size 2>&1 | _filter_dd
                     fi
@@ -2339,18 +2801,18 @@ _nfiles()
 # takes dirname, depth, randomdata
 _descend()
 {
-        dirname=$1; depth=$2; randomdata=$3
+        local dirname=$1 depth=$2 randomdata=$3
         mkdir $dirname  || die "mkdir $dirname failed"
         cd $dirname
 
         _nfiles $files $randomdata          # files for this dir and data type
 
         [ $depth -eq 0 ] && return
-       let deep=$depth-1 # go 1 down
+        local deep=$(( depth - 1 )) # go 1 down
 
         [ $verbose = true ] && echo "descending, depth from leaves = $deep"
 
-        d=0
+        local d=0
         while [ $d -lt $dirs ]
         do
                 _descend d$d $deep &
@@ -2365,17 +2827,18 @@ _descend()
 #
 _populate_fs()
 {
-    here=`pwd`
-    dirs=5          # ndirs in each subdir till leaves
-    size=0          # sizeof files in K
-    files=100       # num files in _each_ subdir
-    depth=2         # depth of tree from root to leaves
-    verbose=false
-    root=root       # path of initial root of directory tree
-    randomdata=false # -x data type urandom or zero
+    local here=`pwd`
+    local dirs=5          # ndirs in each subdir till leaves
+    local size=0          # sizeof files in K
+    local files=100       # num files in _each_ subdir
+    local depth=2         # depth of tree from root to leaves
+    local verbose=false
+    local root=root       # path of initial root of directory tree
+    local randomdata=false # -x data type urandom, zero or compressible
+    local c
 
     OPTIND=1
-    while getopts "d:f:n:r:s:v:x" c
+    while getopts "d:f:n:r:s:v:x:c" c
     do
         case $c in
         d)      depth=$OPTARG;;
@@ -2385,6 +2848,7 @@ _populate_fs()
         v)      verbose=true;;
         r)      root=$OPTARG;;
         x)      randomdata=true;;
+        c)      randomdata=comp;;
         esac
     done
 
@@ -2400,8 +2864,8 @@ _populate_fs()
 #
 _test_inode_flag()
 {
-       flag=$1
-       file=$2
+       local flag=$1
+       local file=$2
 
        if $XFS_IO_PROG -r -c 'lsattr -v' "$file" | grep -q "$flag" ; then
                return 0
@@ -2413,8 +2877,8 @@ _test_inode_flag()
 #
 _test_inode_extsz()
 {
-       file=$1
-       blocks=""
+       local file=$1
+       local blocks=""
 
        blocks=`$XFS_IO_PROG -r -c 'stat' "$file" | \
                awk '/^xattr.extsize =/ { print $3 }'`
@@ -2474,15 +2938,15 @@ _require_scratch_dev_pool()
 # must be called after _require_scratch_dev_pool
 _require_scratch_dev_pool_equal_size()
 {
-       local _size
-       local _newsize
-       local _dev
+       local size
+       local newsize
+       local dev
 
        # SCRATCH_DEV has been set to the first device in SCRATCH_DEV_POOL
-       _size=`_get_device_size $SCRATCH_DEV`
-       for _dev in $SCRATCH_DEV_POOL; do
-               _newsize=`_get_device_size $_dev`
-               if [ $_size -ne $_newsize ]; then
+       size=`_get_device_size $SCRATCH_DEV`
+       for dev in $SCRATCH_DEV_POOL; do
+               newsize=`_get_device_size $dev`
+               if [ $size -ne $newsize ]; then
                        _notrun "This test requires devices in SCRATCH_DEV_POOL have the same size"
                fi
        done
@@ -2504,7 +2968,7 @@ _require_deletable_scratch_dev_pool()
 # Check that fio is present, and it is able to execute given jobfile
 _require_fio()
 {
-       job=$1
+       local job=$1
 
        _require_command "$FIO_PROG" fio
        if [ -z "$1" ]; then
@@ -2519,27 +2983,66 @@ _require_fio()
 _require_freeze()
 {
        xfs_freeze -f "$TEST_DIR" >/dev/null 2>&1
-       result=$? 
+       local result=$?
        xfs_freeze -u "$TEST_DIR" >/dev/null 2>&1
        [ $result -eq 0 ] || _notrun "$FSTYP does not support freezing"
 }
 
+# Does NFS export work on this fs?
+_require_exportfs()
+{
+       _require_test_program "open_by_handle"
+       mkdir -p "$TEST_DIR"/exportfs_test
+       $here/src/open_by_handle -c "$TEST_DIR"/exportfs_test 2>&1 \
+               || _notrun "$FSTYP does not support NFS export"
+}
+
+
 # Does shutdown work on this fs?
 _require_scratch_shutdown()
 {
        [ -x src/godown ] || _notrun "src/godown executable not found"
 
-       _scratch_mkfs > /dev/null 2>&1
+       _scratch_mkfs > /dev/null 2>&1 || _notrun "_scratch_mkfs failed on $SCRATCH_DEV"
        _scratch_mount
-       src/godown -f $SCRATCH_MNT 2>&1 \
-               || _notrun "$FSTYP does not support shutdown"
+
+       if [ $FSTYP = "overlay" ]; then
+               if [ -z $OVL_BASE_SCRATCH_DEV ]; then
+                       # In lagacy overlay usage, it may specify directory as
+                       # SCRATCH_DEV, in this case OVL_BASE_SCRATCH_DEV
+                       # will be null, so check OVL_BASE_SCRATCH_DEV before
+                       # running shutdown to avoid shutting down base fs accidently.
+                       _notrun "$SCRATCH_DEV is not a block device"
+               else
+                       src/godown -f $OVL_BASE_SCRATCH_MNT 2>&1 \
+                       || _notrun "Underlying filesystem does not support shutdown"
+               fi
+       else
+               src/godown -f $SCRATCH_MNT 2>&1 \
+                       || _notrun "$FSTYP does not support shutdown"
+       fi
+
+       _scratch_unmount
+}
+
+# Does dax mount option work on this dev/fs?
+_require_scratch_dax()
+{
+       _require_scratch
+       _scratch_mkfs > /dev/null 2>&1
+       _try_scratch_mount -o dax || \
+               _notrun "mount $SCRATCH_DEV with dax failed"
+       # Check options to be sure. XFS ignores dax option
+       # and goes on if dev underneath does not support dax.
+       _fs_options $SCRATCH_DEV | grep -qw "dax" || \
+               _notrun "$SCRATCH_DEV $FSTYP does not support -o dax"
        _scratch_unmount
 }
 
 # Does norecovery support by this fs?
 _require_norecovery()
 {
-       _scratch_mount -o ro,norecovery || \
+       _try_scratch_mount -o ro,norecovery || \
                _notrun "$FSTYP does not support norecovery"
        _scratch_unmount
 }
@@ -2555,35 +3058,41 @@ _require_norecovery()
 _require_metadata_journaling()
 {
        if [ -z $1 ]; then
-               DEV=$TEST_DEV
+               local dev=$TEST_DEV
        else
-               DEV=$1
+               local dev=$1
        fi
 
        case "$FSTYP" in
-       ext2|vfat|msdos)
+       ext2|vfat|msdos|udf)
                _notrun "$FSTYP does not support metadata journaling"
                ;;
        ext4)
                # ext4 could be mkfs'd without a journal...
                _require_dumpe2fs
-               $DUMPE2FS_PROG -h $DEV 2>&1 | grep -q has_journal || \
-                       _notrun "$FSTYP on $DEV not configured with metadata journaling"
+               $DUMPE2FS_PROG -h $dev 2>&1 | grep -q has_journal || \
+                       _notrun "$FSTYP on $dev not configured with metadata journaling"
                # ext4 might not load a journal
                _exclude_scratch_mount_option "noload"
                ;;
+       overlay)
+               # metadata journaling check is based on base filesystem configurations
+               # and  because -overlay option saves those configurations to OVL_BASE_*,
+               # adding restore/override the configurations before/after the check.
+               if [ ! -z $OVL_BASE_FSTYP -a $OVL_BASE_FSTYP != "overlay" ]; then
+                       _overlay_config_restore
+                       _require_metadata_journaling
+                       _overlay_config_override
+               else
+                       _notrun "No metadata journaling support for legacy overlay setup"
+               fi
+               ;;
        *)
                # by default we pass; if you need to, add your fs above!
                ;;
        esac
 }
 
-# Does fiemap support?
-_require_fiemap()
-{
-       _require_xfs_io_command "fiemap"
-}
-
 _count_extents()
 {
        $XFS_IO_PROG -c "fiemap" $1 | tail -n +2 | grep -v hole | wc -l
@@ -2594,6 +3103,11 @@ _count_holes()
        $XFS_IO_PROG -c "fiemap" $1 | tail -n +2 | grep hole | wc -l
 }
 
+_count_attr_extents()
+{
+       $XFS_IO_PROG -c "fiemap -a" $1 | tail -n +2 | grep -v hole | wc -l
+}
+
 # arg 1 is dev to remove and is output of the below eg.
 # ls -l /sys/class/block/sdd | rev | cut -d "/" -f 3 | rev
 _devmgt_remove()
@@ -2623,10 +3137,12 @@ _devmgt_add()
        echo ${tdl} >  /sys/class/scsi_host/host${h}/scan || _fail "Add disk failed"
 
        # ensure the device comes online
-       dev_back_oneline=0
+       local dev_back_oneline=0
+       local i
        for i in `seq 1 10`; do
                if [ -d /sys/class/scsi_device/${1}/device/block ]; then
-                       dev=`ls /sys/class/scsi_device/${1}/device/block`
+                       local dev=`ls /sys/class/scsi_device/${1}/device/block`
+                       local j
                        for j in `seq 1 10`;
                        do
                                stat /dev/$dev > /dev/null 2>&1
@@ -2727,7 +3243,7 @@ _require_atime()
 _require_relatime()
 {
         _scratch_mkfs > /dev/null 2>&1
-        _scratch_mount -o relatime || \
+        _try_scratch_mount -o relatime || \
                 _notrun "relatime not supported by the current kernel"
        _scratch_unmount
 }
@@ -2740,20 +3256,20 @@ _require_userns()
 
 _create_loop_device()
 {
-       file=$1
+       local file=$1 dev
        dev=`losetup -f --show $file` || _fail "Cannot assign $file to a loop device"
        echo $dev
 }
 
 _destroy_loop_device()
 {
-       dev=$1
+       local dev=$1
        losetup -d $dev || _fail "Cannot destroy loop device $dev"
 }
 
 _scale_fsstress_args()
 {
-    args=""
+    local args=""
     while [ $# -gt 0 ]; do
         case "$1" in
             -n) args="$args $1 $(($2 * $TIME_FACTOR))"; shift ;;
@@ -2771,7 +3287,7 @@ _scale_fsstress_args()
 #
 _min_dio_alignment()
 {
-    dev=$1
+    local dev=$1
 
     if [ -b "$dev" ]; then
         blockdev --getss $dev
@@ -2788,11 +3304,8 @@ run_check()
 
 _require_test_symlinks()
 {
-       # IRIX UDF does not support symlinks
-       [ "$HOSTOS" = "IRIX" -a "$FSTYP" = 'udf' ] && \
-               _notrun "Require symlinks support"
-       target=`mktemp -p $TEST_DIR`
-       link=`mktemp -p $TEST_DIR -u`
+       local target=`mktemp -p $TEST_DIR`
+       local link=`mktemp -p $TEST_DIR -u`
        ln -s `basename $target` $link
        if [ "$?" -ne 0 ]; then
                rm -f $target
@@ -2809,9 +3322,20 @@ _require_test_fcntl_advisory_locks()
                _notrun "Require fcntl advisory locks support"
 }
 
+_require_ofd_locks()
+{
+       # Give a test run by getlk wrlck on testfile.
+       # If the running kernel does not support OFD locks,
+       # EINVAL will be returned.
+       _require_test_program "t_ofd_locks"
+       touch $TEST_DIR/ofd_testfile
+       src/t_ofd_locks -t $TEST_DIR/ofd_testfile > /dev/null 2>&1
+       [ $? -eq 22 ] && _notrun "Require OFD locks support"
+}
+
 _require_test_lsattr()
 {
-       testio=$(lsattr -d $TEST_DIR 2>&1)
+       local testio=$(lsattr -d $TEST_DIR 2>&1)
        echo $testio | grep -q "Operation not supported" && \
                _notrun "lsattr not supported by test filesystem type: $FSTYP"
        echo $testio | grep -q "Inappropriate ioctl for device" && \
@@ -2820,18 +3344,21 @@ _require_test_lsattr()
 
 _require_chattr()
 {
-    attribute=$1
-
-    touch $TEST_DIR/syscalltest
-    chattr "+$attribute" $TEST_DIR/syscalltest > $TEST_DIR/syscalltest.out 2>&1
-    status=$?
-    chattr "-$attribute" $TEST_DIR/syscalltest > $TEST_DIR/syscalltest.out 2>&1
-    if [ "$status" -ne 0 ]; then
-      _notrun "file system doesn't support chattr +$attribute"
-    fi
-    cat $TEST_DIR/syscalltest.out >> $seqres.full
+       if [ -z "$1" ]; then
+               echo "Usage: _require_chattr <attr>"
+               exit 1
+       fi
+       local attribute=$1
 
-    rm -f $TEST_DIR/syscalltest.out
+       touch $TEST_DIR/syscalltest
+       chattr "+$attribute" $TEST_DIR/syscalltest > $TEST_DIR/syscalltest.out 2>&1
+       local ret=$?
+       chattr "-$attribute" $TEST_DIR/syscalltest > $TEST_DIR/syscalltest.out 2>&1
+       if [ "$ret" -ne 0 ]; then
+               _notrun "file system doesn't support chattr +$attribute"
+       fi
+       cat $TEST_DIR/syscalltest.out >> $seqres.full
+       rm -f $TEST_DIR/syscalltest.out
 }
 
 _get_total_inode()
@@ -2898,6 +3425,31 @@ _get_device_size()
        grep `_short_dev $1` /proc/partitions | awk '{print $3}'
 }
 
+# Make sure we actually have dmesg checking set up.
+_require_check_dmesg()
+{
+       test -w /dev/kmsg || \
+               _notrun "Test requires writable /dev/kmsg."
+}
+
+# Return the dmesg log since the start of this test.  Caller must ensure that
+# /dev/kmsg was writable when the test was started so that we can find the
+# beginning of this test's log messages; _require_check_dmesg does this.
+_dmesg_since_test_start()
+{
+       # search the dmesg log of last run of $seqnum for possible failures
+       # use sed \cregexpc address type, since $seqnum contains "/"
+       dmesg | tac | sed -ne "0,\#run fstests $seqnum at $date_time#p" | \
+               tac
+}
+
+# check dmesg log for a specific string, subject to the same requirements as
+# _dmesg_since_test_start.
+_check_dmesg_for()
+{
+       _dmesg_since_test_start | egrep -q "$1"
+}
+
 # check dmesg log for WARNING/Oops/etc.
 _check_dmesg()
 {
@@ -2909,24 +3461,23 @@ _check_dmesg()
        # default filter is a simple cat command, caller could provide a
        # customized filter and pass the name through the first argument, to
        # filter out intentional WARNINGs or Oopses
-       filter=${1:-cat}
+       local filter=${1:-cat}
 
-       # search the dmesg log of last run of $seqnum for possible failures
-       # use sed \cregexpc address type, since $seqnum contains "/"
-       dmesg | tac | sed -ne "0,\#run fstests $seqnum at $date_time#p" | \
-               tac | $filter >$seqres.dmesg
-       grep -q -e "kernel BUG at" \
+       _dmesg_since_test_start | $filter >$seqres.dmesg
+       egrep -q -e "kernel BUG at" \
             -e "WARNING:" \
             -e "BUG:" \
             -e "Oops:" \
             -e "possible recursive locking detected" \
             -e "Internal error" \
-            -e "INFO: suspicious RCU usage" \
+            -e "(INFO|ERR): suspicious RCU usage" \
             -e "INFO: possible circular locking dependency detected" \
             -e "general protection fault:" \
+            -e "BUG .* remaining" \
+            -e "UBSAN:" \
             $seqres.dmesg
        if [ $? -eq 0 ]; then
-               echo "_check_dmesg: something found in dmesg (see $seqres.dmesg)"
+               _dump_err "_check_dmesg: something found in dmesg (see $seqres.dmesg)"
                return 1
        else
                rm -f $seqres.dmesg
@@ -2934,6 +3485,66 @@ _check_dmesg()
        fi
 }
 
+# capture the kmemleak report
+_capture_kmemleak()
+{
+       local kern_knob="${DEBUGFS_MNT}/kmemleak"
+       local leak_file="$1"
+
+       # Tell the kernel to scan for memory leaks.  Apparently the write
+       # returns before the scan is complete, so do it twice in the hopes
+       # that twice is enough to capture all the leaks.
+       echo "scan" > "$kern_knob"
+       cat "$kern_knob" > /dev/null
+       echo "scan" > "$kern_knob"
+       cat "$kern_knob" > "$leak_file.tmp"
+       if [ -s "$leak_file.tmp" ]; then
+               cat > "$leak_file" << ENDL
+EXPERIMENTAL kmemleak reported some memory leaks!  Due to the way kmemleak
+works, the leak might be from an earlier test, or something totally unrelated.
+ENDL
+               cat "$leak_file.tmp" >> "$leak_file"
+       fi
+       rm -rf "$leak_file.tmp"
+       echo "clear" > "$kern_knob"
+}
+
+# set up kmemleak
+_init_kmemleak()
+{
+       local kern_knob="${DEBUGFS_MNT}/kmemleak"
+
+       if [ ! -w "$kern_knob" ]; then
+               return 0
+       fi
+
+       # Disable the automatic scan so that we can control it completely,
+       # then dump all the leaks recorded so far.
+       echo "scan=off" > "$kern_knob"
+       _capture_kmemleak /dev/null
+}
+
+# check kmemleak log
+_check_kmemleak()
+{
+       local kern_knob="${DEBUGFS_MNT}/kmemleak"
+       local leak_file="${seqres}.kmemleak"
+
+       if [ ! -w "$kern_knob" ]; then
+               return 0
+       fi
+
+       # Capture and report any leaks
+       _capture_kmemleak "$leak_file"
+       if [ -s "$leak_file" ]; then
+               _dump_err "_check_kmemleak: something found in kmemleak (see $leak_file)"
+               return 1
+       else
+               rm -f "$leak_file"
+               return 0
+       fi
+}
+
 # don't check dmesg log after test
 _disable_dmesg_check()
 {
@@ -2969,13 +3580,17 @@ init_rc()
                fi
        fi
 
-       if [ "`_fs_type $TEST_DEV`" != "$FSTYP" ]
-       then
-               echo "common/rc: Error: \$TEST_DEV ($TEST_DEV) is not a MOUNTED $FSTYP filesystem"
-               # raw $DF_PROG cannot handle NFS/CIFS/overlay correctly
-               _df_device $TEST_DEV
-               exit 1
+       # Sanity check that TEST partition is not mounted at another mount point
+       # or as another fs type
+       _check_mounted_on TEST_DEV $TEST_DEV TEST_DIR $TEST_DIR $FSTYP || exit 1
+       if [ -n "$SCRATCH_DEV" ]; then
+               # Sanity check that SCRATCH partition is not mounted at another
+               # mount point, because it is about to be unmounted and formatted.
+               # Another fs type for scratch is fine (bye bye old fs type).
+               _check_mounted_on SCRATCH_DEV $SCRATCH_DEV SCRATCH_MNT $SCRATCH_MNT
+               [ $? -le 1 ] || exit 1
        fi
+
        # Figure out if we need to add -F ("foreign", deprecated) option to xfs_io
        $XFS_IO_PROG -c stat $TEST_DIR 2>&1 | grep -q "is not on an XFS filesystem" && \
                export XFS_IO_PROG="$XFS_IO_PROG -F"
@@ -3006,11 +3621,11 @@ init_rc()
 # get real device path name by following link
 _real_dev()
 {
-       local _dev=$1
-       if [ -b "$_dev" ] && [ -L "$_dev" ]; then
-               _dev=`readlink -f "$_dev"`
+       local dev=$1
+       if [ -b "$dev" ] && [ -L "$dev" ]; then
+               dev=`readlink -f "$dev"`
        fi
-       echo $_dev
+       echo $dev
 }
 
 # basename of a device
@@ -3021,21 +3636,38 @@ _short_dev()
 
 _sysfs_dev()
 {
-       local _dev=`_real_dev $1`
-       local _maj=$(stat -c%t $_dev | tr [:lower:] [:upper:])
-       local _min=$(stat -c%T $_dev | tr [:lower:] [:upper:])
-       _maj=$(echo "ibase=16; $_maj" | bc)
-       _min=$(echo "ibase=16; $_min" | bc)
-       echo /sys/dev/block/$_maj:$_min
+       local dev=`_real_dev $1`
+       local maj=$(stat -c%t $dev | tr [:lower:] [:upper:])
+       local min=$(stat -c%T $dev | tr [:lower:] [:upper:])
+       maj=$(echo "ibase=16; $maj" | bc)
+       min=$(echo "ibase=16; $min" | bc)
+       echo /sys/dev/block/$maj:$min
 }
 
-get_block_size()
+# Get the minimum block size of a file.  Usually this is the
+# minimum fs block size, but some filesystems (ocfs2) do block
+# mappings in larger units.
+_get_file_block_size()
 {
        if [ -z $1 ] || [ ! -d $1 ]; then
-               echo "Missing mount point argument for get_block_size"
+               echo "Missing mount point argument for _get_file_block_size"
                exit 1
        fi
-       echo `stat -f -c %S $1`
+       if [ "$FSTYP" = "ocfs2" ]; then
+               stat -c '%o' $1
+       else
+               _get_block_size $1
+       fi
+}
+
+# Get the minimum block size of an fs.
+_get_block_size()
+{
+       if [ -z $1 ] || [ ! -d $1 ]; then
+               echo "Missing mount point argument for _get_block_size"
+               exit 1
+       fi
+       stat -f -c %S $1
 }
 
 get_page_size()
@@ -3047,15 +3679,17 @@ get_page_size()
 run_fsx()
 {
        echo fsx $@
-       args=`echo $@ | sed -e "s/ BSIZE / $bsize /g" -e "s/ PSIZE / $psize /g"`
+       local args=`echo $@ | sed -e "s/ BSIZE / $bsize /g" -e "s/ PSIZE / $psize /g"`
        set -- $here/ltp/fsx $args $FSX_AVOID $TEST_DIR/junk
        echo "$@" >>$seqres.full
        rm -f $TEST_DIR/junk
        "$@" 2>&1 | tee -a $seqres.full >$tmp.fsx
        if [ ${PIPESTATUS[0]} -ne 0 ]; then
                cat $tmp.fsx
+               rm -f $tmp.fsx
                exit 1
        fi
+       rm -f $tmp.fsx
 }
 
 # Test for the existence of a sysfs entry at /sys/fs/$FSTYP/DEV/$ATTR
@@ -3079,6 +3713,12 @@ _require_fs_sysfs()
        fi
 }
 
+_require_statx()
+{
+       $here/src/stat_test --check-statx ||
+       _notrun "This test requires the statx system call"
+}
+
 # Write "content" into /sys/fs/$FSTYP/$DEV/$ATTR
 #
 # All arguments are necessary, and in this order:
@@ -3125,7 +3765,21 @@ _get_fs_sysfs_attr()
        cat /sys/fs/${FSTYP}/${dname}/${attr}
 }
 
+# Generic test for specific filesystem feature.
+# Currently only implemented to test overlayfs features.
+_require_scratch_feature()
+{
+       local feature=$1
 
+       case "$FSTYP" in
+       overlay)
+               _require_scratch_overlay_features ${feature}
+               ;;
+       *)
+               _fail "Test for feature '${feature}' of ${FSTYP} is not implemented"
+               ;;
+       esac
+}
 
 init_rc